import { __module as Y } from "../../../_virtual/ext-language_tools.ts";
(function(X, Z) {
  ace.define("ace/snippets", ["require", "exports", "module", "ace/lib/dom", "ace/lib/oop", "ace/lib/event_emitter", "ace/lib/lang", "ace/range", "ace/range_list", "ace/keyboard/hash_handler", "ace/tokenizer", "ace/clipboard", "ace/editor"], function(g, C, V) {
    var _ = g("./lib/dom"), T = g("./lib/oop"), R = g("./lib/event_emitter").EventEmitter, b = g("./lib/lang"), d = g("./range").Range, m = g("./range_list").RangeList, S = g("./keyboard/hash_handler").HashHandler, L = g("./tokenizer").Tokenizer, $ = g("./clipboard"), N = {
      CURRENT_WORD: function(e) {
        return e.session.getTextRange(e.session.getWordRange());
      },
      SELECTION: function(e, i, t) {
        var n = e.session.getTextRange();
        return t ? n.replace(/\n\r?([ \t]*\S)/g, `
` + t + "$1") : n;
      },
      CURRENT_LINE: function(e) {
        return e.session.getLine(e.getCursorPosition().row);
      },
      PREV_LINE: function(e) {
        return e.session.getLine(e.getCursorPosition().row - 1);
      },
      LINE_INDEX: function(e) {
        return e.getCursorPosition().row;
      },
      LINE_NUMBER: function(e) {
        return e.getCursorPosition().row + 1;
      },
      SOFT_TABS: function(e) {
        return e.session.getUseSoftTabs() ? "YES" : "NO";
      },
      TAB_SIZE: function(e) {
        return e.session.getTabSize();
      },
      CLIPBOARD: function(e) {
        return $.getText && $.getText();
      },
      FILENAME: function(e) {
        return /[^/\\]*$/.exec(this.FILEPATH(e))[0];
      },
      FILENAME_BASE: function(e) {
        return /[^/\\]*$/.exec(this.FILEPATH(e))[0].replace(/\.[^.]*$/, "");
      },
      DIRECTORY: function(e) {
        return this.FILEPATH(e).replace(/[^/\\]*$/, "");
      },
      FILEPATH: function(e) {
        return "/not implemented.txt";
      },
      WORKSPACE_NAME: function() {
        return "Unknown";
      },
      FULLNAME: function() {
        return "Unknown";
      },
      BLOCK_COMMENT_START: function(e) {
        var i = e.session.$mode || {};
        return i.blockComment && i.blockComment.start || "";
      },
      BLOCK_COMMENT_END: function(e) {
        var i = e.session.$mode || {};
        return i.blockComment && i.blockComment.end || "";
      },
      LINE_COMMENT: function(e) {
        var i = e.session.$mode || {};
        return i.lineCommentStart || "";
      },
      CURRENT_YEAR: E.bind(null, { year: "numeric" }),
      CURRENT_YEAR_SHORT: E.bind(null, { year: "2-digit" }),
      CURRENT_MONTH: E.bind(null, { month: "numeric" }),
      CURRENT_MONTH_NAME: E.bind(null, { month: "long" }),
      CURRENT_MONTH_NAME_SHORT: E.bind(null, { month: "short" }),
      CURRENT_DATE: E.bind(null, { day: "2-digit" }),
      CURRENT_DAY_NAME: E.bind(null, { weekday: "long" }),
      CURRENT_DAY_NAME_SHORT: E.bind(null, { weekday: "short" }),
      CURRENT_HOUR: E.bind(null, { hour: "2-digit", hour12: !1 }),
      CURRENT_MINUTE: E.bind(null, { minute: "2-digit" }),
      CURRENT_SECOND: E.bind(null, { second: "2-digit" })
    };
    N.SELECTED_TEXT = N.SELECTION;
    function E(e) {
      var i = (/* @__PURE__ */ new Date()).toLocaleString("en-us", e);
      return i.length == 1 ? "0" + i : i;
    }
    var O = (
      /** @class */
      function() {
        function e() {
          this.snippetMap = {}, this.snippetNameMap = {}, this.variables = N;
        }
        return e.prototype.getTokenizer = function() {
          return e.$tokenizer || this.createTokenizer();
        }, e.prototype.createTokenizer = function() {
          function i(o) {
            return o = o.substr(1), /^\d+$/.test(o) ? [{ tabstopId: parseInt(o, 10) }] : [{ text: o }];
          }
          function t(o) {
            return "(?:[^\\\\" + o + "]|\\\\.)";
          }
          var n = {
            regex: "/(" + t("/") + "+)/",
            onMatch: function(o, l, p) {
              var a = p[0];
              return a.fmtString = !0, a.guard = o.slice(1, -1), a.flag = "", "";
            },
            next: "formatString"
          };
          return e.$tokenizer = new L({
            start: [
              { regex: /\\./, onMatch: function(o, l, p) {
                var a = o[1];
                return (a == "}" && p.length || "`$\\".indexOf(a) != -1) && (o = a), [o];
              } },
              { regex: /}/, onMatch: function(o, l, p) {
                return [p.length ? p.shift() : o];
              } },
              { regex: /\$(?:\d+|\w+)/, onMatch: i },
              { regex: /\$\{[\dA-Z_a-z]+/, onMatch: function(o, l, p) {
                var a = i(o.substr(1));
                return p.unshift(a[0]), a;
              }, next: "snippetVar" },
              { regex: /\n/, token: "newline", merge: !1 }
            ],
            snippetVar: [
              { regex: "\\|" + t("\\|") + "*\\|", onMatch: function(o, l, p) {
                var a = o.slice(1, -1).replace(/\\[,|\\]|,/g, function(c) {
                  return c.length == 2 ? c[1] : "\0";
                }).split("\0").map(function(c) {
                  return { value: c };
                });
                return p[0].choices = a, [a[0]];
              }, next: "start" },
              n,
              { regex: "([^:}\\\\]|\\\\.)*:?", token: "", next: "start" }
            ],
            formatString: [
              { regex: /:/, onMatch: function(o, l, p) {
                return p.length && p[0].expectElse ? (p[0].expectElse = !1, p[0].ifEnd = { elseEnd: p[0] }, [p[0].ifEnd]) : ":";
              } },
              { regex: /\\./, onMatch: function(o, l, p) {
                var a = o[1];
                return a == "}" && p.length || "`$\\".indexOf(a) != -1 ? o = a : a == "n" ? o = `
` : a == "t" ? o = "	" : "ulULE".indexOf(a) != -1 && (o = { changeCase: a, local: a > "a" }), [o];
              } },
              { regex: "/\\w*}", onMatch: function(o, l, p) {
                var a = p.shift();
                return a && (a.flag = o.slice(1, -1)), this.next = a && a.tabstopId ? "start" : "", [a || o];
              }, next: "start" },
              { regex: /\$(?:\d+|\w+)/, onMatch: function(o, l, p) {
                return [{ text: o.slice(1) }];
              } },
              { regex: /\${\w+/, onMatch: function(o, l, p) {
                var a = { text: o.slice(2) };
                return p.unshift(a), [a];
              }, next: "formatStringVar" },
              { regex: /\n/, token: "newline", merge: !1 },
              { regex: /}/, onMatch: function(o, l, p) {
                var a = p.shift();
                return this.next = a && a.tabstopId ? "start" : "", [a || o];
              }, next: "start" }
            ],
            formatStringVar: [
              { regex: /:\/\w+}/, onMatch: function(o, l, p) {
                var a = p[0];
                return a.formatFunction = o.slice(2, -1), [p.shift()];
              }, next: "formatString" },
              n,
              { regex: /:[\?\-+]?/, onMatch: function(o, l, p) {
                o[1] == "+" && (p[0].ifEnd = p[0]), o[1] == "?" && (p[0].expectElse = !0);
              }, next: "formatString" },
              { regex: "([^:}\\\\]|\\\\.)*:?", token: "", next: "formatString" }
            ]
          }), e.$tokenizer;
        }, e.prototype.tokenizeTmSnippet = function(i, t) {
          return this.getTokenizer().getLineTokens(i, t).tokens.map(function(n) {
            return n.value || n;
          });
        }, e.prototype.getVariableValue = function(i, t, n) {
          if (/^\d+$/.test(t))
            return (this.variables.__ || {})[t] || "";
          if (/^[A-Z]\d+$/.test(t))
            return (this.variables[t[0] + "__"] || {})[t.substr(1)] || "";
          if (t = t.replace(/^TM_/, ""), !this.variables.hasOwnProperty(t))
            return "";
          var o = this.variables[t];
          return typeof o == "function" && (o = this.variables[t](i, t, n)), o ?? "";
        }, e.prototype.tmStrFormat = function(i, t, n) {
          if (!t.fmt)
            return i;
          var o = t.flag || "", l = t.guard;
          l = new RegExp(l, o.replace(/[^gim]/g, ""));
          var p = typeof t.fmt == "string" ? this.tokenizeTmSnippet(t.fmt, "formatString") : t.fmt, a = this, c = i.replace(l, function() {
            var s = a.variables.__;
            a.variables.__ = [].slice.call(arguments);
            for (var u = a.resolveVariables(p, n), v = "E", f = 0; f < u.length; f++) {
              var y = u[f];
              if (typeof y == "object")
                if (u[f] = "", y.changeCase && y.local) {
                  var x = u[f + 1];
                  x && typeof x == "string" && (y.changeCase == "u" ? u[f] = x[0].toUpperCase() : u[f] = x[0].toLowerCase(), u[f + 1] = x.substr(1));
                } else
                  y.changeCase && (v = y.changeCase);
              else
                v == "U" ? u[f] = y.toUpperCase() : v == "L" && (u[f] = y.toLowerCase());
            }
            return a.variables.__ = s, u.join("");
          });
          return c;
        }, e.prototype.tmFormatFunction = function(i, t, n) {
          return t.formatFunction == "upcase" ? i.toUpperCase() : t.formatFunction == "downcase" ? i.toLowerCase() : i;
        }, e.prototype.resolveVariables = function(i, t) {
          for (var n = [], o = "", l = !0, p = 0; p < i.length; p++) {
            var a = i[p];
            if (typeof a == "string") {
              n.push(a), a == `
` ? (l = !0, o = "") : l && (o = /^\t*/.exec(a)[0], l = /\S/.test(a));
              continue;
            }
            if (a) {
              if (l = !1, a.fmtString) {
                var c = i.indexOf(a, p + 1);
                c == -1 && (c = i.length), a.fmt = i.slice(p + 1, c), p = c;
              }
              if (a.text) {
                var s = this.getVariableValue(t, a.text, o) + "";
                a.fmtString && (s = this.tmStrFormat(s, a, t)), a.formatFunction && (s = this.tmFormatFunction(s, a, t)), s && !a.ifEnd ? (n.push(s), u(a)) : !s && a.ifEnd && u(a.ifEnd);
              } else
                a.elseEnd ? u(a.elseEnd) : (a.tabstopId != null || a.changeCase != null) && n.push(a);
            }
          }
          function u(v) {
            var f = i.indexOf(v, p + 1);
            f != -1 && (p = f);
          }
          return n;
        }, e.prototype.getDisplayTextForSnippet = function(i, t) {
          var n = k.call(this, i, t);
          return n.text;
        }, e.prototype.insertSnippetForSelection = function(i, t, n) {
          n === void 0 && (n = {});
          var o = k.call(this, i, t, n), l = i.getSelectionRange(), p = i.session.replace(l, o.text), a = new F(i), c = i.inVirtualSelectionMode && i.selection.index;
          a.addTabstops(o.tabstops, l.start, p, c);
        }, e.prototype.insertSnippet = function(i, t, n) {
          n === void 0 && (n = {});
          var o = this;
          if (i.inVirtualSelectionMode)
            return o.insertSnippetForSelection(i, t, n);
          i.forEachSelection(function() {
            o.insertSnippetForSelection(i, t, n);
          }, null, { keepOrder: !0 }), i.tabstopManager && i.tabstopManager.tabNext();
        }, e.prototype.$getScope = function(i) {
          var t = i.session.$mode.$id || "";
          if (t = t.split("/").pop(), t === "html" || t === "php") {
            t === "php" && !i.session.$mode.inlinePhp && (t = "html");
            var n = i.getCursorPosition(), o = i.session.getState(n.row);
            typeof o == "object" && (o = o[0]), o.substring && (o.substring(0, 3) == "js-" ? t = "javascript" : o.substring(0, 4) == "css-" ? t = "css" : o.substring(0, 4) == "php-" && (t = "php"));
          }
          return t;
        }, e.prototype.getActiveScopes = function(i) {
          var t = this.$getScope(i), n = [t], o = this.snippetMap;
          return o[t] && o[t].includeScopes && n.push.apply(n, o[t].includeScopes), n.push("_"), n;
        }, e.prototype.expandWithTab = function(i, t) {
          var n = this, o = i.forEachSelection(function() {
            return n.expandSnippetForSelection(i, t);
          }, null, { keepOrder: !0 });
          return o && i.tabstopManager && i.tabstopManager.tabNext(), o;
        }, e.prototype.expandSnippetForSelection = function(i, t) {
          var n = i.getCursorPosition(), o = i.session.getLine(n.row), l = o.substring(0, n.column), p = o.substr(n.column), a = this.snippetMap, c;
          return this.getActiveScopes(i).some(function(s) {
            var u = a[s];
            return u && (c = this.findMatchingSnippet(u, l, p)), !!c;
          }, this), c ? (t && t.dryRun || (i.session.doc.removeInLine(n.row, n.column - c.replaceBefore.length, n.column + c.replaceAfter.length), this.variables.M__ = c.matchBefore, this.variables.T__ = c.matchAfter, this.insertSnippetForSelection(i, c.content), this.variables.M__ = this.variables.T__ = null), !0) : !1;
        }, e.prototype.findMatchingSnippet = function(i, t, n) {
          for (var o = i.length; o--; ) {
            var l = i[o];
            if (!(l.startRe && !l.startRe.test(t)) && !(l.endRe && !l.endRe.test(n)) && !(!l.startRe && !l.endRe))
              return l.matchBefore = l.startRe ? l.startRe.exec(t) : [""], l.matchAfter = l.endRe ? l.endRe.exec(n) : [""], l.replaceBefore = l.triggerRe ? l.triggerRe.exec(t)[0] : "", l.replaceAfter = l.endTriggerRe ? l.endTriggerRe.exec(n)[0] : "", l;
          }
        }, e.prototype.register = function(i, t) {
          var n = this.snippetMap, o = this.snippetNameMap, l = this;
          i || (i = []);
          function p(s) {
            return s && !/^\^?\(.*\)\$?$|^\\b$/.test(s) && (s = "(?:" + s + ")"), s || "";
          }
          function a(s, u, v) {
            return s = p(s), u = p(u), v ? (s = u + s, s && s[s.length - 1] != "$" && (s = s + "$")) : (s = s + u, s && s[0] != "^" && (s = "^" + s)), new RegExp(s);
          }
          function c(s) {
            s.scope || (s.scope = t || "_"), t = s.scope, n[t] || (n[t] = [], o[t] = {});
            var u = o[t];
            if (s.name) {
              var v = u[s.name];
              v && l.unregister(v), u[s.name] = s;
            }
            n[t].push(s), s.prefix && (s.tabTrigger = s.prefix), !s.content && s.body && (s.content = Array.isArray(s.body) ? s.body.join(`
`) : s.body), s.tabTrigger && !s.trigger && (!s.guard && /^\w/.test(s.tabTrigger) && (s.guard = "\\b"), s.trigger = b.escapeRegExp(s.tabTrigger)), !(!s.trigger && !s.guard && !s.endTrigger && !s.endGuard) && (s.startRe = a(s.trigger, s.guard, !0), s.triggerRe = new RegExp(s.trigger), s.endRe = a(s.endTrigger, s.endGuard, !0), s.endTriggerRe = new RegExp(s.endTrigger));
          }
          Array.isArray(i) ? i.forEach(c) : Object.keys(i).forEach(function(s) {
            c(i[s]);
          }), this._signal("registerSnippets", { scope: t });
        }, e.prototype.unregister = function(i, t) {
          var n = this.snippetMap, o = this.snippetNameMap;
          function l(p) {
            var a = o[p.scope || t];
            if (a && a[p.name]) {
              delete a[p.name];
              var c = n[p.scope || t], s = c && c.indexOf(p);
              s >= 0 && c.splice(s, 1);
            }
          }
          i.content ? l(i) : Array.isArray(i) && i.forEach(l);
        }, e.prototype.parseSnippetFile = function(i) {
          i = i.replace(/\r/g, "");
          for (var t = [], n = {}, o = /^#.*|^({[\s\S]*})\s*$|^(\S+) (.*)$|^((?:\n*\t.*)+)/gm, l; l = o.exec(i); ) {
            if (l[1])
              try {
                n = JSON.parse(l[1]), t.push(n);
              } catch {
              }
            if (l[4])
              n.content = l[4].replace(/^\t/gm, ""), t.push(n), n = {};
            else {
              var p = l[2], a = l[3];
              if (p == "regex") {
                var c = /\/((?:[^\/\\]|\\.)*)|$/g;
                n.guard = c.exec(a)[1], n.trigger = c.exec(a)[1], n.endTrigger = c.exec(a)[1], n.endGuard = c.exec(a)[1];
              } else
                p == "snippet" ? (n.tabTrigger = a.match(/^\S*/)[0], n.name || (n.name = a)) : p && (n[p] = a);
            }
          }
          return t;
        }, e.prototype.getSnippetByName = function(i, t) {
          var n = this.snippetNameMap, o;
          return this.getActiveScopes(t).some(function(l) {
            var p = n[l];
            return p && (o = p[i]), !!o;
          }, this), o;
        }, e;
      }()
    );
    T.implement(O.prototype, R);
    var k = function(e, i, t) {
      t === void 0 && (t = {});
      var n = e.getCursorPosition(), o = e.session.getLine(n.row), l = e.session.getTabString(), p = o.match(/^\s*/)[0];
      n.column < p.length && (p = p.slice(0, n.column)), i = i.replace(/\r/g, "");
      var a = this.tokenizeTmSnippet(i);
      a = this.resolveVariables(a, e), a = a.map(function(w) {
        return w == `
` && !t.excludeExtraIndent ? w + p : typeof w == "string" ? w.replace(/\t/g, l) : w;
      });
      var c = [];
      a.forEach(function(w, H) {
        if (typeof w == "object") {
          var B = w.tabstopId, P = c[B];
          if (P || (P = c[B] = [], P.index = B, P.value = "", P.parents = {}), P.indexOf(w) === -1) {
            w.choices && !P.choices && (P.choices = w.choices), P.push(w);
            var W = a.indexOf(w, H + 1);
            if (W !== -1) {
              var G = a.slice(H + 1, W), K = G.some(function(j) {
                return typeof j == "object";
              });
              K && !P.value ? P.value = G : G.length && (!P.value || typeof P.value != "string") && (P.value = G.join(""));
            }
          }
        }
      }), c.forEach(function(w) {
        w.length = 0;
      });
      var s = {};
      function u(w) {
        for (var H = [], B = 0; B < w.length; B++) {
          var P = w[B];
          if (typeof P == "object") {
            if (s[P.tabstopId])
              continue;
            var W = w.lastIndexOf(P, B - 1);
            P = H[W] || { tabstopId: P.tabstopId };
          }
          H[B] = P;
        }
        return H;
      }
      for (var v = 0; v < a.length; v++) {
        var f = a[v];
        if (typeof f == "object") {
          var y = f.tabstopId, x = c[y], M = a.indexOf(f, v + 1);
          if (s[y]) {
            s[y] === f && (delete s[y], Object.keys(s).forEach(function(w) {
              x.parents[w] = !0;
            }));
            continue;
          }
          s[y] = f;
          var D = x.value;
          typeof D != "string" ? D = u(D) : f.fmt && (D = this.tmStrFormat(D, f, e)), a.splice.apply(a, [v + 1, Math.max(0, M - v)].concat(D, f)), x.indexOf(f) === -1 && x.push(f);
        }
      }
      var A = 0, z = 0, U = "";
      return a.forEach(function(w) {
        if (typeof w == "string") {
          var H = w.split(`
`);
          H.length > 1 ? (z = H[H.length - 1].length, A += H.length - 1) : z += w.length, U += w;
        } else
          w && (w.start ? w.end = { row: A, column: z } : w.start = { row: A, column: z });
      }), {
        text: U,
        tabstops: c,
        tokens: a
      };
    }, F = (
      /** @class */
      function() {
        function e(i) {
          if (this.index = 0, this.ranges = [], this.tabstops = [], i.tabstopManager)
            return i.tabstopManager;
          i.tabstopManager = this, this.$onChange = this.onChange.bind(this), this.$onChangeSelection = b.delayedCall(this.onChangeSelection.bind(this)).schedule, this.$onChangeSession = this.onChangeSession.bind(this), this.$onAfterExec = this.onAfterExec.bind(this), this.attach(i);
        }
        return e.prototype.attach = function(i) {
          this.$openTabstops = null, this.selectedTabstop = null, this.editor = i, this.session = i.session, this.editor.on("change", this.$onChange), this.editor.on("changeSelection", this.$onChangeSelection), this.editor.on("changeSession", this.$onChangeSession), this.editor.commands.on("afterExec", this.$onAfterExec), this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler);
        }, e.prototype.detach = function() {
          this.tabstops.forEach(this.removeTabstopMarkers, this), this.ranges.length = 0, this.tabstops.length = 0, this.selectedTabstop = null, this.editor.off("change", this.$onChange), this.editor.off("changeSelection", this.$onChangeSelection), this.editor.off("changeSession", this.$onChangeSession), this.editor.commands.off("afterExec", this.$onAfterExec), this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler), this.editor.tabstopManager = null, this.session = null, this.editor = null;
        }, e.prototype.onChange = function(i) {
          for (var t = i.action[0] == "r", n = this.selectedTabstop || {}, o = n.parents || {}, l = this.tabstops.slice(), p = 0; p < l.length; p++) {
            var a = l[p], c = a == n || o[a.index];
            if (a.rangeList.$bias = c ? 0 : 1, i.action == "remove" && a !== n) {
              var s = a.parents && a.parents[n.index], u = a.rangeList.pointIndex(i.start, s);
              u = u < 0 ? -u - 1 : u + 1;
              var v = a.rangeList.pointIndex(i.end, s);
              v = v < 0 ? -v - 1 : v - 1;
              for (var f = a.rangeList.ranges.slice(u, v), y = 0; y < f.length; y++)
                this.removeRange(f[y]);
            }
            a.rangeList.$onChange(i);
          }
          var x = this.session;
          !this.$inChange && t && x.getLength() == 1 && !x.getValue() && this.detach();
        }, e.prototype.updateLinkedFields = function() {
          var i = this.selectedTabstop;
          if (!(!i || !i.hasLinkedRanges || !i.firstNonLinked)) {
            this.$inChange = !0;
            for (var t = this.session, n = t.getTextRange(i.firstNonLinked), o = 0; o < i.length; o++) {
              var l = i[o];
              if (l.linked) {
                var p = l.original, a = C.snippetManager.tmStrFormat(n, p, this.editor);
                t.replace(l, a);
              }
            }
            this.$inChange = !1;
          }
        }, e.prototype.onAfterExec = function(i) {
          i.command && !i.command.readOnly && this.updateLinkedFields();
        }, e.prototype.onChangeSelection = function() {
          if (this.editor) {
            for (var i = this.editor.selection.lead, t = this.editor.selection.anchor, n = this.editor.selection.isEmpty(), o = 0; o < this.ranges.length; o++)
              if (!this.ranges[o].linked) {
                var l = this.ranges[o].contains(i.row, i.column), p = n || this.ranges[o].contains(t.row, t.column);
                if (l && p)
                  return;
              }
            this.detach();
          }
        }, e.prototype.onChangeSession = function() {
          this.detach();
        }, e.prototype.tabNext = function(i) {
          var t = this.tabstops.length, n = this.index + (i || 1);
          n = Math.min(Math.max(n, 1), t), n == t && (n = 0), this.selectTabstop(n), this.updateTabstopMarkers(), n === 0 && this.detach();
        }, e.prototype.selectTabstop = function(i) {
          this.$openTabstops = null;
          var t = this.tabstops[this.index];
          if (t && this.addTabstopMarkers(t), this.index = i, t = this.tabstops[this.index], !(!t || !t.length)) {
            this.selectedTabstop = t;
            var n = t.firstNonLinked || t;
            if (t.choices && (n.cursor = n.start), this.editor.inVirtualSelectionMode)
              this.editor.selection.fromOrientedRange(n);
            else {
              var o = this.editor.multiSelect;
              o.toSingleRange(n);
              for (var l = 0; l < t.length; l++)
                t.hasLinkedRanges && t[l].linked || o.addRange(t[l].clone(), !0);
            }
            this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler), this.selectedTabstop && this.selectedTabstop.choices && this.editor.execCommand("startAutocomplete", { matches: this.selectedTabstop.choices });
          }
        }, e.prototype.addTabstops = function(i, t, n) {
          var o = this.useLink || !this.editor.getOption("enableMultiselect");
          if (this.$openTabstops || (this.$openTabstops = []), !i[0]) {
            var l = d.fromPoints(n, n);
            h(l.start, t), h(l.end, t), i[0] = [l], i[0].index = 0;
          }
          var p = this.index, a = [p + 1, 0], c = this.ranges, s = this.snippetId = (this.snippetId || 0) + 1;
          i.forEach(function(u, v) {
            var f = this.$openTabstops[v] || u;
            f.snippetId = s;
            for (var y = 0; y < u.length; y++) {
              var x = u[y], M = d.fromPoints(x.start, x.end || x.start);
              I(M.start, t), I(M.end, t), M.original = x, M.tabstop = f, c.push(M), f != u ? f.unshift(M) : f[y] = M, x.fmtString || f.firstNonLinked && o ? (M.linked = !0, f.hasLinkedRanges = !0) : f.firstNonLinked || (f.firstNonLinked = M);
            }
            f.firstNonLinked || (f.hasLinkedRanges = !1), f === u && (a.push(f), this.$openTabstops[v] = f), this.addTabstopMarkers(f), f.rangeList = f.rangeList || new m(), f.rangeList.$bias = 0, f.rangeList.addList(f);
          }, this), a.length > 2 && (this.tabstops.length && a.push(a.splice(2, 1)[0]), this.tabstops.splice.apply(this.tabstops, a));
        }, e.prototype.addTabstopMarkers = function(i) {
          var t = this.session;
          i.forEach(function(n) {
            n.markerId || (n.markerId = t.addMarker(n, "ace_snippet-marker", "text"));
          });
        }, e.prototype.removeTabstopMarkers = function(i) {
          var t = this.session;
          i.forEach(function(n) {
            t.removeMarker(n.markerId), n.markerId = null;
          });
        }, e.prototype.updateTabstopMarkers = function() {
          if (this.selectedTabstop) {
            var i = this.selectedTabstop.snippetId;
            this.selectedTabstop.index === 0 && i--, this.tabstops.forEach(function(t) {
              t.snippetId === i ? this.addTabstopMarkers(t) : this.removeTabstopMarkers(t);
            }, this);
          }
        }, e.prototype.removeRange = function(i) {
          var t = i.tabstop.indexOf(i);
          t != -1 && i.tabstop.splice(t, 1), t = this.ranges.indexOf(i), t != -1 && this.ranges.splice(t, 1), t = i.tabstop.rangeList.ranges.indexOf(i), t != -1 && i.tabstop.splice(t, 1), this.session.removeMarker(i.markerId), i.tabstop.length || (t = this.tabstops.indexOf(i.tabstop), t != -1 && this.tabstops.splice(t, 1), this.tabstops.length || this.detach());
        }, e;
      }()
    );
    F.prototype.keyboardHandler = new S(), F.prototype.keyboardHandler.bindKeys({
      Tab: function(e) {
        C.snippetManager && C.snippetManager.expandWithTab(e) || (e.tabstopManager.tabNext(1), e.renderer.scrollCursorIntoView());
      },
      "Shift-Tab": function(e) {
        e.tabstopManager.tabNext(-1), e.renderer.scrollCursorIntoView();
      },
      Esc: function(e) {
        e.tabstopManager.detach();
      }
    });
    var I = function(e, i) {
      e.row == 0 && (e.column += i.column), e.row += i.row;
    }, h = function(e, i) {
      e.row == i.row && (e.column -= i.column), e.row -= i.row;
    };
    _.importCssString(`
.ace_snippet-marker {
    -moz-box-sizing: border-box;
    box-sizing: border-box;
    background: rgba(194, 193, 208, 0.09);
    border: 1px dotted rgba(211, 208, 235, 0.62);
    position: absolute;
}`, "snippets.css", !1), C.snippetManager = new O();
    var r = g("./editor").Editor;
    (function() {
      this.insertSnippet = function(e, i) {
        return C.snippetManager.insertSnippet(this, e, i);
      }, this.expandSnippet = function(e) {
        return C.snippetManager.expandWithTab(this, e);
      };
    }).call(r.prototype);
  }), ace.define("ace/autocomplete/popup", ["require", "exports", "module", "ace/virtual_renderer", "ace/editor", "ace/range", "ace/lib/event", "ace/lib/lang", "ace/lib/dom", "ace/config", "ace/lib/useragent"], function(g, C, V) {
    var _ = g("../virtual_renderer").VirtualRenderer, T = g("../editor").Editor, R = g("../range").Range, b = g("../lib/event"), d = g("../lib/lang"), m = g("../lib/dom"), S = g("../config").nls, L = g("./../lib/useragent"), $ = function(I) {
      return "suggest-aria-id:".concat(I);
    }, N = L.isSafari ? "menu" : "listbox", E = L.isSafari ? "menuitem" : "option", O = L.isSafari ? "aria-current" : "aria-selected", k = function(I) {
      var h = new _(I);
      h.$maxLines = 4;
      var r = new T(h);
      return r.setHighlightActiveLine(!1), r.setShowPrintMargin(!1), r.renderer.setShowGutter(!1), r.renderer.setHighlightGutterLine(!1), r.$mouseHandler.$focusTimeout = 0, r.$highlightTagPending = !0, r;
    }, F = (
      /** @class */
      function() {
        function I(h) {
          var r = m.createElement("div"), e = k(r);
          h && h.appendChild(r), r.style.display = "none", e.renderer.content.style.cursor = "default", e.renderer.setStyle("ace_autocomplete"), e.renderer.$textLayer.element.setAttribute("role", N), e.renderer.$textLayer.element.setAttribute("aria-roledescription", S("autocomplete.popup.aria-roledescription", "Autocomplete suggestions")), e.renderer.$textLayer.element.setAttribute("aria-label", S("autocomplete.popup.aria-label", "Autocomplete suggestions")), e.renderer.textarea.setAttribute("aria-hidden", "true"), e.setOption("displayIndentGuides", !1), e.setOption("dragDelay", 150);
          var i = function() {
          };
          e.focus = i, e.$isFocused = !0, e.renderer.$cursorLayer.restartTimer = i, e.renderer.$cursorLayer.element.style.opacity = "0", e.renderer.$maxLines = 8, e.renderer.$keepTextAreaAtCursor = !1, e.setHighlightActiveLine(!1), e.session.highlight(""), e.session.$searchHighlight.clazz = "ace_highlight-marker", e.on("mousedown", function(c) {
            var s = c.getDocumentPosition();
            e.selection.moveToPosition(s), o.start.row = o.end.row = s.row, c.stop();
          });
          var t, n = new R(-1, 0, -1, 1 / 0), o = new R(-1, 0, -1, 1 / 0);
          o.id = e.session.addMarker(o, "ace_active-line", "fullLine"), e.setSelectOnHover = function(c) {
            c ? n.id && (e.session.removeMarker(n.id), n.id = null) : n.id = e.session.addMarker(n, "ace_line-hover", "fullLine");
          }, e.setSelectOnHover(!1), e.on("mousemove", function(c) {
            if (!t) {
              t = c;
              return;
            }
            if (!(t.x == c.x && t.y == c.y)) {
              t = c, t.scrollTop = e.renderer.scrollTop, e.isMouseOver = !0;
              var s = t.getDocumentPosition().row;
              n.start.row != s && (n.id || e.setRow(s), p(s));
            }
          }), e.renderer.on("beforeRender", function() {
            if (t && n.start.row != -1) {
              t.$pos = null;
              var c = t.getDocumentPosition().row;
              n.id || e.setRow(c), p(c, !0);
            }
          }), e.renderer.on("afterRender", function() {
            var c = e.getRow(), s = e.renderer.$textLayer, u = (
              /** @type {HTMLElement|null} */
              s.element.childNodes[c - s.config.firstRow]
            ), v = document.activeElement;
            if (u !== e.selectedNode && e.selectedNode && (m.removeCssClass(e.selectedNode, "ace_selected"), v.removeAttribute("aria-activedescendant"), e.selectedNode.removeAttribute(O), e.selectedNode.removeAttribute("id")), e.selectedNode = u, u) {
              m.addCssClass(u, "ace_selected");
              var f = $(c);
              u.id = f, s.element.setAttribute("aria-activedescendant", f), v.setAttribute("aria-activedescendant", f), u.setAttribute("role", E), u.setAttribute("aria-roledescription", S("autocomplete.popup.item.aria-roledescription", "item")), u.setAttribute("aria-label", e.getData(c).caption || e.getData(c).value), u.setAttribute("aria-setsize", e.data.length), u.setAttribute("aria-posinset", c + 1), u.setAttribute("aria-describedby", "doc-tooltip"), u.setAttribute(O, "true");
            }
          });
          var l = function() {
            p(-1);
          }, p = function(c, s) {
            c !== n.start.row && (n.start.row = n.end.row = c, s || e.session._emit("changeBackMarker"), e._emit("changeHoverMarker"));
          };
          e.getHoveredRow = function() {
            return n.start.row;
          }, b.addListener(e.container, "mouseout", function() {
            e.isMouseOver = !1, l();
          }), e.on("hide", l), e.on("changeSelection", l), e.session.doc.getLength = function() {
            return e.data.length;
          }, e.session.doc.getLine = function(c) {
            var s = e.data[c];
            return typeof s == "string" ? s : s && s.value || "";
          };
          var a = e.session.bgTokenizer;
          return a.$tokenizeRow = function(c) {
            var s = e.data[c], u = [];
            if (!s)
              return u;
            typeof s == "string" && (s = { value: s });
            var v = s.caption || s.value || s.name;
            function f(w, H) {
              w && u.push({
                type: (s.className || "") + (H || ""),
                value: w
              });
            }
            for (var y = v.toLowerCase(), x = (e.filterText || "").toLowerCase(), M = 0, D = 0, A = 0; A <= x.length; A++)
              if (A != D && (s.matchMask & 1 << A || A == x.length)) {
                var z = x.slice(D, A);
                D = A;
                var U = y.indexOf(z, M);
                if (U == -1)
                  continue;
                f(v.slice(M, U), ""), M = U + z.length, f(v.slice(U, M), "completion-highlight");
              }
            return f(v.slice(M, v.length), ""), u.push({ type: "completion-spacer", value: " " }), s.meta && u.push({ type: "completion-meta", value: s.meta }), s.message && u.push({ type: "completion-message", value: s.message }), u;
          }, a.$updateOnChange = i, a.start = i, e.session.$computeWidth = function() {
            return this.screenWidth = 0;
          }, e.isOpen = !1, e.isTopdown = !1, e.autoSelect = !0, e.filterText = "", e.isMouseOver = !1, e.data = [], e.setData = function(c, s) {
            e.filterText = s || "", e.setValue(d.stringRepeat(`
`, c.length), -1), e.data = c || [], e.setRow(0);
          }, e.getData = function(c) {
            return e.data[c];
          }, e.getRow = function() {
            return o.start.row;
          }, e.setRow = function(c) {
            c = Math.max(this.autoSelect ? 0 : -1, Math.min(this.data.length - 1, c)), o.start.row != c && (e.selection.clearSelection(), o.start.row = o.end.row = c || 0, e.session._emit("changeBackMarker"), e.moveCursorTo(c || 0, 0), e.isOpen && e._signal("select"));
          }, e.on("changeSelection", function() {
            e.isOpen && e.setRow(e.selection.lead.row), e.renderer.scrollCursorIntoView();
          }), e.hide = function() {
            this.container.style.display = "none", e.anchorPos = null, e.anchor = null, e.isOpen && (e.isOpen = !1, this._signal("hide"));
          }, e.tryShow = function(c, s, u, v) {
            if (!v && e.isOpen && e.anchorPos && e.anchor && e.anchorPos.top === c.top && e.anchorPos.left === c.left && e.anchor === u)
              return !0;
            var f = this.container, y = window.innerHeight, x = window.innerWidth, M = this.renderer, D = M.$maxLines * s * 1.4, A = { top: 0, bottom: 0, left: 0 }, z = y - c.top - 3 * this.$borderSize - s, U = c.top - 3 * this.$borderSize;
            u || (U <= z || z >= D ? u = "bottom" : u = "top"), u === "top" ? (A.bottom = c.top - this.$borderSize, A.top = A.bottom - D) : u === "bottom" && (A.top = c.top + s + this.$borderSize, A.bottom = A.top + D);
            var w = A.top >= 0 && A.bottom <= y;
            if (!v && !w)
              return !1;
            w ? M.$maxPixelHeight = null : u === "top" ? M.$maxPixelHeight = U : M.$maxPixelHeight = z, u === "top" ? (f.style.top = "", f.style.bottom = y - A.bottom + "px", e.isTopdown = !1) : (f.style.top = A.top + "px", f.style.bottom = "", e.isTopdown = !0), f.style.display = "";
            var H = c.left;
            return H + f.offsetWidth > x && (H = x - f.offsetWidth), f.style.left = H + "px", f.style.right = "", e.isOpen || (e.isOpen = !0, this._signal("show"), t = null), e.anchorPos = c, e.anchor = u, !0;
          }, e.show = function(c, s, u) {
            this.tryShow(c, s, u ? "bottom" : void 0, !0);
          }, e.goTo = function(c) {
            var s = this.getRow(), u = this.session.getLength() - 1;
            switch (c) {
              case "up":
                s = s <= 0 ? u : s - 1;
                break;
              case "down":
                s = s >= u ? -1 : s + 1;
                break;
              case "start":
                s = 0;
                break;
              case "end":
                s = u;
                break;
            }
            this.setRow(s);
          }, e.getTextLeftOffset = function() {
            return this.$borderSize + this.renderer.$padding + this.$imageSize;
          }, e.$imageSize = 0, e.$borderSize = 1, e;
        }
        return I;
      }()
    );
    m.importCssString(`
.ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line {
    background-color: #CAD6FA;
    z-index: 1;
}
.ace_dark.ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line {
    background-color: #3a674e;
}
.ace_editor.ace_autocomplete .ace_line-hover {
    border: 1px solid #abbffe;
    margin-top: -1px;
    background: rgba(233,233,253,0.4);
    position: absolute;
    z-index: 2;
}
.ace_dark.ace_editor.ace_autocomplete .ace_line-hover {
    border: 1px solid rgba(109, 150, 13, 0.8);
    background: rgba(58, 103, 78, 0.62);
}
.ace_completion-meta {
    opacity: 0.5;
    margin-left: 0.9em;
}
.ace_completion-message {
    margin-left: 0.9em;
    color: blue;
}
.ace_editor.ace_autocomplete .ace_completion-highlight{
    color: #2d69c7;
}
.ace_dark.ace_editor.ace_autocomplete .ace_completion-highlight{
    color: #93ca12;
}
.ace_editor.ace_autocomplete {
    width: 300px;
    z-index: 200000;
    border: 1px lightgray solid;
    position: fixed;
    box-shadow: 2px 3px 5px rgba(0,0,0,.2);
    line-height: 1.4;
    background: #fefefe;
    color: #111;
}
.ace_dark.ace_editor.ace_autocomplete {
    border: 1px #484747 solid;
    box-shadow: 2px 3px 5px rgba(0, 0, 0, 0.51);
    line-height: 1.4;
    background: #25282c;
    color: #c1c1c1;
}
.ace_autocomplete .ace_text-layer  {
    width: calc(100% - 8px);
}
.ace_autocomplete .ace_line {
    display: flex;
    align-items: center;
}
.ace_autocomplete .ace_line > * {
    min-width: 0;
    flex: 0 0 auto;
}
.ace_autocomplete .ace_line .ace_ {
    flex: 0 1 auto;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
}
.ace_autocomplete .ace_completion-spacer {
    flex: 1;
}
.ace_autocomplete.ace_loading:after  {
    content: "";
    position: absolute;
    top: 0px;
    height: 2px;
    width: 8%;
    background: blue;
    z-index: 100;
    animation: ace_progress 3s infinite linear;
    animation-delay: 300ms;
    transform: translateX(-100%) scaleX(1);
}
@keyframes ace_progress {
    0% { transform: translateX(-100%) scaleX(1) }
    50% { transform: translateX(625%) scaleX(2) } 
    100% { transform: translateX(1500%) scaleX(3) } 
}
@media (prefers-reduced-motion) {
    .ace_autocomplete.ace_loading:after {
        transform: translateX(625%) scaleX(2);
        animation: none;
     }
}
`, "autocompletion.css", !1), C.AcePopup = F, C.$singleLineEditor = k, C.getAriaId = $;
  }), ace.define("ace/autocomplete/inline_screenreader", ["require", "exports", "module"], function(g, C, V) {
    var _ = (
      /** @class */
      function() {
        function T(R) {
          this.editor = R, this.screenReaderDiv = document.createElement("div"), this.screenReaderDiv.classList.add("ace_screenreader-only"), this.editor.container.appendChild(this.screenReaderDiv);
        }
        return T.prototype.setScreenReaderContent = function(R) {
          for (!this.popup && this.editor.completer && /**@type{import("../autocomplete").Autocomplete}*/
          this.editor.completer.popup && (this.popup = /**@type{import("../autocomplete").Autocomplete}*/
          this.editor.completer.popup, this.popup.renderer.on("afterRender", (function() {
            var d = this.popup.getRow(), m = this.popup.renderer.$textLayer, S = m.element.childNodes[d - m.config.firstRow];
            if (S) {
              for (var L = "doc-tooltip ", $ = 0; $ < this._lines.length; $++)
                L += "ace-inline-screenreader-line-".concat($, " ");
              S.setAttribute("aria-describedby", L);
            }
          }).bind(this))); this.screenReaderDiv.firstChild; )
            this.screenReaderDiv.removeChild(this.screenReaderDiv.firstChild);
          this._lines = R.split(/\r\n|\r|\n/);
          var b = this.createCodeBlock();
          this.screenReaderDiv.appendChild(b);
        }, T.prototype.destroy = function() {
          this.screenReaderDiv.remove();
        }, T.prototype.createCodeBlock = function() {
          var R = document.createElement("pre");
          R.setAttribute("id", "ace-inline-screenreader");
          for (var b = 0; b < this._lines.length; b++) {
            var d = document.createElement("code");
            d.setAttribute("id", "ace-inline-screenreader-line-".concat(b));
            var m = document.createTextNode(this._lines[b]);
            d.appendChild(m), R.appendChild(d);
          }
          return R;
        }, T;
      }()
    );
    C.AceInlineScreenReader = _;
  }), ace.define("ace/autocomplete/inline", ["require", "exports", "module", "ace/snippets", "ace/autocomplete/inline_screenreader"], function(g, C, V) {
    var _ = g("../snippets").snippetManager, T = g("./inline_screenreader").AceInlineScreenReader, R = (
      /** @class */
      function() {
        function b() {
          this.editor = null;
        }
        return b.prototype.show = function(d, m, S) {
          if (S = S || "", d && this.editor && this.editor !== d && (this.hide(), this.editor = null, this.inlineScreenReader = null), !d || !m)
            return !1;
          this.inlineScreenReader || (this.inlineScreenReader = new T(d));
          var L = m.snippet ? _.getDisplayTextForSnippet(d, m.snippet) : m.value;
          return m.hideInlinePreview || !L || !L.startsWith(S) ? !1 : (this.editor = d, this.inlineScreenReader.setScreenReaderContent(L), L = L.slice(S.length), L === "" ? d.removeGhostText() : d.setGhostText(L), !0);
        }, b.prototype.isOpen = function() {
          return this.editor ? !!this.editor.renderer.$ghostText : !1;
        }, b.prototype.hide = function() {
          return this.editor ? (this.editor.removeGhostText(), !0) : !1;
        }, b.prototype.destroy = function() {
          this.hide(), this.editor = null, this.inlineScreenReader && (this.inlineScreenReader.destroy(), this.inlineScreenReader = null);
        }, b;
      }()
    );
    C.AceInline = R;
  }), ace.define("ace/autocomplete/util", ["require", "exports", "module"], function(g, C, V) {
    C.parForEach = function(T, R, b) {
      var d = 0, m = T.length;
      m === 0 && b();
      for (var S = 0; S < m; S++)
        R(T[S], function(L, $) {
          d++, d === m && b(L, $);
        });
    };
    var _ = /[a-zA-Z_0-9\$\-\u00A2-\u2000\u2070-\uFFFF]/;
    C.retrievePrecedingIdentifier = function(T, R, b) {
      b = b || _;
      for (var d = [], m = R - 1; m >= 0 && b.test(T[m]); m--)
        d.push(T[m]);
      return d.reverse().join("");
    }, C.retrieveFollowingIdentifier = function(T, R, b) {
      b = b || _;
      for (var d = [], m = R; m < T.length && b.test(T[m]); m++)
        d.push(T[m]);
      return d;
    }, C.getCompletionPrefix = function(T) {
      var R = T.getCursorPosition(), b = T.session.getLine(R.row), d;
      return T.completers.forEach((function(m) {
        m.identifierRegexps && m.identifierRegexps.forEach((function(S) {
          !d && S && (d = this.retrievePrecedingIdentifier(b, R.column, S));
        }).bind(this));
      }).bind(this)), d || this.retrievePrecedingIdentifier(b, R.column);
    }, C.triggerAutocomplete = function(T, b) {
      var b = b ?? T.session.getPrecedingCharacter();
      return T.completers.some(function(d) {
        if (d.triggerCharacters && Array.isArray(d.triggerCharacters))
          return d.triggerCharacters.includes(b);
      });
    };
  }), ace.define("ace/autocomplete", ["require", "exports", "module", "ace/keyboard/hash_handler", "ace/autocomplete/popup", "ace/autocomplete/inline", "ace/autocomplete/popup", "ace/autocomplete/util", "ace/lib/lang", "ace/lib/dom", "ace/snippets", "ace/config", "ace/lib/event", "ace/lib/scroll"], function(g, C, V) {
    var _ = g("./keyboard/hash_handler").HashHandler, T = g("./autocomplete/popup").AcePopup, R = g("./autocomplete/inline").AceInline, b = g("./autocomplete/popup").getAriaId, d = g("./autocomplete/util"), m = g("./lib/lang"), S = g("./lib/dom"), L = g("./snippets").snippetManager, $ = g("./config"), N = g("./lib/event"), E = g("./lib/scroll").preventParentScroll, O = function(h, r) {
      r.completer && r.completer.destroy();
    }, k = (
      /** @class */
      function() {
        function h() {
          this.autoInsert = !1, this.autoSelect = !0, this.autoShown = !1, this.exactMatch = !1, this.inlineEnabled = !1, this.keyboardHandler = new _(), this.keyboardHandler.bindKeys(this.commands), this.parentNode = null, this.setSelectOnHover = !1, this.hasSeen = /* @__PURE__ */ new Set(), this.showLoadingState = !1, this.stickySelectionDelay = 500, this.blurListener = this.blurListener.bind(this), this.changeListener = this.changeListener.bind(this), this.mousedownListener = this.mousedownListener.bind(this), this.mousewheelListener = this.mousewheelListener.bind(this), this.onLayoutChange = this.onLayoutChange.bind(this), this.changeTimer = m.delayedCall((function() {
            this.updateCompletions(!0);
          }).bind(this)), this.tooltipTimer = m.delayedCall(this.updateDocTooltip.bind(this), 50), this.popupTimer = m.delayedCall(this.$updatePopupPosition.bind(this), 50), this.stickySelectionTimer = m.delayedCall((function() {
            this.stickySelection = !0;
          }).bind(this), this.stickySelectionDelay), this.$firstOpenTimer = m.delayedCall(
            /**@this{Autocomplete}*/
            (function() {
              var r = this.completionProvider && this.completionProvider.initialPosition;
              this.autoShown || this.popup && this.popup.isOpen || !r || this.editor.completers.length === 0 || (this.completions = new I(h.completionsForLoading), this.openPopup(this.editor, r.prefix, !1), this.popup.renderer.setStyle("ace_loading", !0));
            }).bind(this),
            this.stickySelectionDelay
          );
        }
        return Object.defineProperty(h, "completionsForLoading", {
          get: function() {
            return [{
              caption: $.nls("autocomplete.loading", "Loading..."),
              value: ""
            }];
          },
          enumerable: !1,
          configurable: !0
        }), h.prototype.$init = function() {
          return this.popup = new T(this.parentNode || document.body || document.documentElement), this.popup.on("click", (function(r) {
            this.insertMatch(), r.stop();
          }).bind(this)), this.popup.focus = this.editor.focus.bind(this.editor), this.popup.on("show", this.$onPopupShow.bind(this)), this.popup.on("hide", this.$onHidePopup.bind(this)), this.popup.on("select", this.$onPopupChange.bind(this)), N.addListener(this.popup.container, "mouseout", this.mouseOutListener.bind(this)), this.popup.on("changeHoverMarker", this.tooltipTimer.bind(null, null)), this.popup.renderer.on("afterRender", this.$onPopupRender.bind(this)), this.popup;
        }, h.prototype.$initInline = function() {
          if (!(!this.inlineEnabled || this.inlineRenderer))
            return this.inlineRenderer = new R(), this.inlineRenderer;
        }, h.prototype.getPopup = function() {
          return this.popup || this.$init();
        }, h.prototype.$onHidePopup = function() {
          this.inlineRenderer && this.inlineRenderer.hide(), this.hideDocTooltip(), this.stickySelectionTimer.cancel(), this.popupTimer.cancel(), this.stickySelection = !1;
        }, h.prototype.$seen = function(r) {
          !this.hasSeen.has(r) && r && r.completer && r.completer.onSeen && typeof r.completer.onSeen == "function" && (r.completer.onSeen(this.editor, r), this.hasSeen.add(r));
        }, h.prototype.$onPopupChange = function(r) {
          if (this.inlineRenderer && this.inlineEnabled) {
            var e = r ? null : this.popup.getData(this.popup.getRow());
            if (this.$updateGhostText(e), this.popup.isMouseOver && this.setSelectOnHover) {
              this.tooltipTimer.call(null, null);
              return;
            }
            this.popupTimer.schedule(), this.tooltipTimer.schedule();
          } else
            this.popupTimer.call(null, null), this.tooltipTimer.call(null, null);
        }, h.prototype.$updateGhostText = function(r) {
          var e = this.base.row, i = this.base.column, t = this.editor.getCursorPosition().column, n = this.editor.session.getLine(e).slice(i, t);
          this.inlineRenderer.show(this.editor, r, n) ? this.$seen(r) : this.inlineRenderer.hide();
        }, h.prototype.$onPopupRender = function() {
          var r = this.inlineRenderer && this.inlineEnabled;
          if (this.completions && this.completions.filtered && this.completions.filtered.length > 0)
            for (var e = this.popup.getFirstVisibleRow(); e <= this.popup.getLastVisibleRow(); e++) {
              var i = this.popup.getData(e);
              i && (!r || i.hideInlinePreview) && this.$seen(i);
            }
        }, h.prototype.$onPopupShow = function(r) {
          this.$onPopupChange(r), this.stickySelection = !1, this.stickySelectionDelay >= 0 && this.stickySelectionTimer.schedule(this.stickySelectionDelay);
        }, h.prototype.observeLayoutChanges = function() {
          if (!(this.$elements || !this.editor)) {
            window.addEventListener("resize", this.onLayoutChange, { passive: !0 }), window.addEventListener("wheel", this.mousewheelListener);
            for (var r = this.editor.container.parentNode, e = []; r; )
              e.push(r), r.addEventListener("scroll", this.onLayoutChange, { passive: !0 }), r = r.parentNode;
            this.$elements = e;
          }
        }, h.prototype.unObserveLayoutChanges = function() {
          var r = this;
          window.removeEventListener("resize", this.onLayoutChange, { passive: !0 }), window.removeEventListener("wheel", this.mousewheelListener), this.$elements && this.$elements.forEach(function(e) {
            e.removeEventListener("scroll", r.onLayoutChange, { passive: !0 });
          }), this.$elements = null;
        }, h.prototype.onLayoutChange = function() {
          if (!this.popup.isOpen)
            return this.unObserveLayoutChanges();
          this.$updatePopupPosition(), this.updateDocTooltip();
        }, h.prototype.$updatePopupPosition = function() {
          var r = this.editor, e = r.renderer, i = e.layerConfig.lineHeight, t = e.$cursorLayer.getPixelPosition(this.base, !0);
          t.left -= this.popup.getTextLeftOffset();
          var n = r.container.getBoundingClientRect();
          t.top += n.top - e.layerConfig.offset, t.left += n.left - r.renderer.scrollLeft, t.left += e.gutterWidth;
          var o = {
            top: t.top,
            left: t.left
          };
          e.$ghostText && e.$ghostTextWidget && this.base.row === e.$ghostText.position.row && (o.top += e.$ghostTextWidget.el.offsetHeight);
          var l = r.container.getBoundingClientRect().bottom - i, p = l < o.top ? { top: l, left: o.left } : o;
          this.popup.tryShow(p, i, "bottom") || this.popup.tryShow(t, i, "top") || this.popup.show(t, i);
        }, h.prototype.openPopup = function(r, e, i) {
          this.$firstOpenTimer.cancel(), this.popup || this.$init(), this.inlineEnabled && !this.inlineRenderer && this.$initInline(), this.popup.autoSelect = this.autoSelect, this.popup.setSelectOnHover(this.setSelectOnHover);
          var t = this.popup.getRow(), n = this.popup.data[t];
          this.popup.setData(this.completions.filtered, this.completions.filterText), this.editor.textInput.setAriaOptions && this.editor.textInput.setAriaOptions({
            activeDescendant: b(this.popup.getRow()),
            inline: this.inlineEnabled
          }), r.keyBinding.addKeyboardHandler(this.keyboardHandler);
          var o;
          this.stickySelection && (o = this.popup.data.indexOf(n)), (!o || o === -1) && (o = 0), this.popup.setRow(this.autoSelect ? o : -1), o === t && n !== this.completions.filtered[o] && this.$onPopupChange();
          var l = this.inlineRenderer && this.inlineEnabled;
          if (o === t && l) {
            var p = this.popup.getData(this.popup.getRow());
            this.$updateGhostText(p);
          }
          i || (this.popup.setTheme(r.getTheme()), this.popup.setFontSize(r.getFontSize()), this.$updatePopupPosition(), this.tooltipNode && this.updateDocTooltip()), this.changeTimer.cancel(), this.observeLayoutChanges();
        }, h.prototype.detach = function() {
          this.editor && (this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler), this.editor.off("changeSelection", this.changeListener), this.editor.off("blur", this.blurListener), this.editor.off("mousedown", this.mousedownListener), this.editor.off("mousewheel", this.mousewheelListener)), this.$firstOpenTimer.cancel(), this.changeTimer.cancel(), this.hideDocTooltip(), this.completionProvider && this.completionProvider.detach(), this.popup && this.popup.isOpen && this.popup.hide(), this.popup && this.popup.renderer && this.popup.renderer.off("afterRender", this.$onPopupRender), this.base && this.base.detach(), this.activated = !1, this.completionProvider = this.completions = this.base = null, this.unObserveLayoutChanges();
        }, h.prototype.changeListener = function(r) {
          var e = this.editor.selection.lead;
          (e.row != this.base.row || e.column < this.base.column) && this.detach(), this.activated ? this.changeTimer.schedule() : this.detach();
        }, h.prototype.blurListener = function(r) {
          var e = document.activeElement, i = this.editor.textInput.getElement(), t = r.relatedTarget && this.tooltipNode && this.tooltipNode.contains(r.relatedTarget), n = this.popup && this.popup.container;
          e != i && e.parentNode != n && !t && e != this.tooltipNode && r.relatedTarget != i && this.detach();
        }, h.prototype.mousedownListener = function(r) {
          this.detach();
        }, h.prototype.mousewheelListener = function(r) {
          this.popup.isMouseOver || this.detach();
        }, h.prototype.mouseOutListener = function(r) {
          this.popup.isOpen && this.$updatePopupPosition();
        }, h.prototype.goTo = function(r) {
          this.popup.goTo(r);
        }, h.prototype.insertMatch = function(r, e) {
          if (r || (r = this.popup.getData(this.popup.getRow())), !r)
            return !1;
          if (r.value === "")
            return this.detach();
          var i = this.completions, t = this.getCompletionProvider().insertMatch(this.editor, r, i.filterText, e);
          return this.completions == i && this.detach(), t;
        }, h.prototype.showPopup = function(r, e) {
          this.editor && this.detach(), this.activated = !0, this.editor = r, r.completer != this && (r.completer && r.completer.detach(), r.completer = this), r.on("changeSelection", this.changeListener), r.on("blur", this.blurListener), r.on("mousedown", this.mousedownListener), r.on("mousewheel", this.mousewheelListener), this.updateCompletions(!1, e);
        }, h.prototype.getCompletionProvider = function(r) {
          return this.completionProvider || (this.completionProvider = new F(r)), this.completionProvider;
        }, h.prototype.gatherCompletions = function(r, e) {
          return this.getCompletionProvider().gatherCompletions(r, e);
        }, h.prototype.updateCompletions = function(r, e) {
          if (r && this.base && this.completions) {
            var t = this.editor.getCursorPosition(), n = this.editor.session.getTextRange({ start: this.base, end: t });
            if (n == this.completions.filterText)
              return;
            if (this.completions.setFilter(n), !this.completions.filtered.length)
              return this.detach();
            if (this.completions.filtered.length == 1 && this.completions.filtered[0].value == n && !this.completions.filtered[0].snippet)
              return this.detach();
            this.openPopup(this.editor, n, r);
            return;
          }
          if (e && e.matches) {
            var t = this.editor.getSelectionRange().start;
            return this.base = this.editor.session.doc.createAnchor(t.row, t.column), this.base.$insertRight = !0, this.completions = new I(e.matches), this.getCompletionProvider().completions = this.completions, this.openPopup(this.editor, "", r);
          }
          var i = this.editor.getSession(), t = this.editor.getCursorPosition(), n = d.getCompletionPrefix(this.editor);
          this.base = i.doc.createAnchor(t.row, t.column - n.length), this.base.$insertRight = !0;
          var o = {
            exactMatch: this.exactMatch,
            ignoreCaption: this.ignoreCaption
          };
          this.getCompletionProvider({
            prefix: n,
            pos: t
          }).provideCompletions(
            this.editor,
            o,
            (function(l, p, a) {
              var c = p.filtered, s = d.getCompletionPrefix(this.editor);
              if (this.$firstOpenTimer.cancel(), a) {
                if (!c.length) {
                  var u = !this.autoShown && this.emptyMessage;
                  if (typeof u == "function" && (u = this.emptyMessage(s)), u) {
                    var v = [
                      {
                        caption: u,
                        value: ""
                      }
                    ];
                    this.completions = new I(v), this.openPopup(this.editor, s, r), this.popup.renderer.setStyle("ace_loading", !1), this.popup.renderer.setStyle("ace_empty-message", !0);
                    return;
                  }
                  return this.detach();
                }
                if (c.length == 1 && c[0].value == s && !c[0].snippet)
                  return this.detach();
                if (this.autoInsert && !this.autoShown && c.length == 1)
                  return this.insertMatch(c[0]);
              }
              this.completions = !a && this.showLoadingState ? new I(h.completionsForLoading.concat(c), p.filterText) : p, this.openPopup(this.editor, s, r), this.popup.renderer.setStyle("ace_empty-message", !1), this.popup.renderer.setStyle("ace_loading", !a);
            }).bind(this)
          ), this.showLoadingState && !this.autoShown && !(this.popup && this.popup.isOpen) && this.$firstOpenTimer.delay(this.stickySelectionDelay / 2);
        }, h.prototype.cancelContextMenu = function() {
          this.editor.$mouseHandler.cancelContextMenu();
        }, h.prototype.updateDocTooltip = function() {
          var r = this.popup, e = this.completions.filtered, i = e && (e[r.getHoveredRow()] || e[r.getRow()]), t = null;
          if (!i || !this.editor || !this.popup.isOpen)
            return this.hideDocTooltip();
          for (var n = this.editor.completers.length, o = 0; o < n; o++) {
            var l = this.editor.completers[o];
            if (l.getDocTooltip && i.completerId === l.id) {
              t = l.getDocTooltip(i);
              break;
            }
          }
          if (!t && typeof i != "string" && (t = i), typeof t == "string" && (t = { docText: t }), !t || !(t.docHTML || t.docText))
            return this.hideDocTooltip();
          this.showDocTooltip(t);
        }, h.prototype.showDocTooltip = function(r) {
          this.tooltipNode || (this.tooltipNode = S.createElement("div"), this.tooltipNode.style.margin = "0", this.tooltipNode.style.pointerEvents = "auto", this.tooltipNode.style.overscrollBehavior = "contain", this.tooltipNode.tabIndex = -1, this.tooltipNode.onblur = this.blurListener.bind(this), this.tooltipNode.onclick = this.onTooltipClick.bind(this), this.tooltipNode.id = "doc-tooltip", this.tooltipNode.setAttribute("role", "tooltip"), this.tooltipNode.addEventListener("wheel", E));
          var e = this.editor.renderer.theme;
          this.tooltipNode.className = "ace_tooltip ace_doc-tooltip " + (e.isDark ? "ace_dark " : "") + (e.cssClass || "");
          var i = this.tooltipNode;
          r.docHTML ? i.innerHTML = r.docHTML : r.docText && (i.textContent = r.docText), i.parentNode || this.popup.container.appendChild(this.tooltipNode);
          var t = this.popup, n = t.container.getBoundingClientRect();
          i.style.top = t.container.style.top, i.style.bottom = t.container.style.bottom, i.style.display = "block", window.innerWidth - n.right < 320 ? n.left < 320 ? t.isTopdown ? (i.style.top = n.bottom + "px", i.style.left = n.left + "px", i.style.right = "", i.style.bottom = "") : (i.style.top = t.container.offsetTop - i.offsetHeight + "px", i.style.left = n.left + "px", i.style.right = "", i.style.bottom = "") : (i.style.right = window.innerWidth - n.left + "px", i.style.left = "") : (i.style.left = n.right + 1 + "px", i.style.right = "");
        }, h.prototype.hideDocTooltip = function() {
          if (this.tooltipTimer.cancel(), !!this.tooltipNode) {
            var r = this.tooltipNode;
            !this.editor.isFocused() && document.activeElement == r && this.editor.focus(), this.tooltipNode = null, r.parentNode && r.parentNode.removeChild(r);
          }
        }, h.prototype.onTooltipClick = function(r) {
          for (var e = r.target; e && e != this.tooltipNode; ) {
            if (e.nodeName == "A" && e.href) {
              e.rel = "noreferrer", e.target = "_blank";
              break;
            }
            e = e.parentNode;
          }
        }, h.prototype.destroy = function() {
          if (this.detach(), this.popup) {
            this.popup.destroy();
            var r = this.popup.container;
            r && r.parentNode && r.parentNode.removeChild(r);
          }
          this.editor && this.editor.completer == this && (this.editor.off("destroy", O), this.editor.completer = null), this.inlineRenderer = this.popup = this.editor = null;
        }, h;
      }()
    );
    k.prototype.commands = {
      Up: function(h) {
        h.completer.goTo("up");
      },
      Down: function(h) {
        h.completer.goTo("down");
      },
      "Ctrl-Up|Ctrl-Home": function(h) {
        h.completer.goTo("start");
      },
      "Ctrl-Down|Ctrl-End": function(h) {
        h.completer.goTo("end");
      },
      Esc: function(h) {
        h.completer.detach();
      },
      Return: function(h) {
        return h.completer.insertMatch();
      },
      "Shift-Return": function(h) {
        h.completer.insertMatch(null, { deleteSuffix: !0 });
      },
      Tab: function(h) {
        var r = h.completer.insertMatch();
        if (!r && !h.tabstopManager)
          h.completer.goTo("down");
        else
          return r;
      },
      Backspace: function(h) {
        h.execCommand("backspace");
        var r = d.getCompletionPrefix(h);
        !r && h.completer && h.completer.detach();
      },
      PageUp: function(h) {
        h.completer.popup.gotoPageUp();
      },
      PageDown: function(h) {
        h.completer.popup.gotoPageDown();
      }
    }, k.for = function(h) {
      return h.completer instanceof k || (h.completer && (h.completer.destroy(), h.completer = null), $.get("sharedPopups") ? (k.$sharedInstance || (k.$sharedInstance = new k()), h.completer = k.$sharedInstance) : (h.completer = new k(), h.once("destroy", O))), h.completer;
    }, k.startCommand = {
      name: "startAutocomplete",
      exec: function(h, r) {
        var e = k.for(h);
        e.autoInsert = !1, e.autoSelect = !0, e.autoShown = !1, e.showPopup(h, r), e.cancelContextMenu();
      },
      bindKey: "Ctrl-Space|Ctrl-Shift-Space|Alt-Space"
    };
    var F = (
      /** @class */
      function() {
        function h(r) {
          this.initialPosition = r, this.active = !0;
        }
        return h.prototype.insertByIndex = function(r, e, i) {
          return !this.completions || !this.completions.filtered ? !1 : this.insertMatch(r, this.completions.filtered[e], i);
        }, h.prototype.insertMatch = function(r, e, i) {
          if (!e)
            return !1;
          if (r.startOperation({ command: { name: "insertMatch" } }), e.completer && e.completer.insertMatch)
            e.completer.insertMatch(r, e);
          else {
            if (!this.completions)
              return !1;
            var t = this.completions.filterText.length, n = 0;
            if (e.range && e.range.start.row === e.range.end.row && (t -= this.initialPosition.prefix.length, t += this.initialPosition.pos.column - e.range.start.column, n += e.range.end.column - this.initialPosition.pos.column), t || n) {
              var o;
              r.selection.getAllRanges ? o = r.selection.getAllRanges() : o = [r.getSelectionRange()];
              for (var l = 0, p; p = o[l]; l++)
                p.start.column -= t, p.end.column += n, r.session.remove(p);
            }
            e.snippet ? L.insertSnippet(r, e.snippet) : this.$insertString(r, e), e.completer && e.completer.onInsert && typeof e.completer.onInsert == "function" && e.completer.onInsert(r, e), e.command && e.command === "startAutocomplete" && r.execCommand(e.command);
          }
          return r.endOperation(), !0;
        }, h.prototype.$insertString = function(r, e) {
          var i = e.value || e;
          r.execCommand("insertstring", i);
        }, h.prototype.gatherCompletions = function(r, e) {
          var i = r.getSession(), t = r.getCursorPosition(), n = d.getCompletionPrefix(r), o = [];
          this.completers = r.completers;
          var l = r.completers.length;
          return r.completers.forEach(function(p, a) {
            p.getCompletions(r, i, t, n, function(c, s) {
              p.hideInlinePreview && (s = s.map(function(u) {
                return Object.assign(u, { hideInlinePreview: p.hideInlinePreview });
              })), !c && s && (o = o.concat(s)), e(null, {
                prefix: d.getCompletionPrefix(r),
                matches: o,
                finished: --l === 0
              });
            });
          }), !0;
        }, h.prototype.provideCompletions = function(r, e, i) {
          var t = (function(p) {
            var a = p.prefix, c = p.matches;
            this.completions = new I(c), e.exactMatch && (this.completions.exactMatch = !0), e.ignoreCaption && (this.completions.ignoreCaption = !0), this.completions.setFilter(a), (p.finished || this.completions.filtered.length) && i(null, this.completions, p.finished);
          }).bind(this), n = !0, o = null;
          if (this.gatherCompletions(r, (function(p, a) {
            if (this.active) {
              p && (i(p, [], !0), this.detach());
              var c = a.prefix;
              if (c.indexOf(a.prefix) === 0) {
                if (n) {
                  o = a;
                  return;
                }
                t(a);
              }
            }
          }).bind(this)), n = !1, o) {
            var l = o;
            o = null, t(l);
          }
        }, h.prototype.detach = function() {
          this.active = !1, this.completers && this.completers.forEach(function(r) {
            typeof r.cancel == "function" && r.cancel();
          });
        }, h;
      }()
    ), I = (
      /** @class */
      function() {
        function h(r, e) {
          this.all = r, this.filtered = r, this.filterText = e || "", this.exactMatch = !1, this.ignoreCaption = !1;
        }
        return h.prototype.setFilter = function(r) {
          if (r.length > this.filterText && r.lastIndexOf(this.filterText, 0) === 0)
            var e = this.filtered;
          else
            var e = this.all;
          this.filterText = r, e = this.filterCompletions(e, this.filterText), e = e.sort(function(t, n) {
            return n.exactMatch - t.exactMatch || n.$score - t.$score || (t.caption || t.value).localeCompare(n.caption || n.value);
          });
          var i = null;
          e = e.filter(function(t) {
            var n = t.snippet || t.caption || t.value;
            return n === i ? !1 : (i = n, !0);
          }), this.filtered = e;
        }, h.prototype.filterCompletions = function(r, e) {
          var i = [], t = e.toUpperCase(), n = e.toLowerCase();
          e:
            for (var o = 0, l; l = r[o]; o++) {
              var p = !this.ignoreCaption && l.caption || l.value || l.snippet;
              if (p) {
                var a = -1, c = 0, s = 0, u, v;
                if (this.exactMatch) {
                  if (e !== p.substr(0, e.length))
                    continue e;
                } else {
                  var f = p.toLowerCase().indexOf(n);
                  if (f > -1)
                    s = f;
                  else
                    for (var y = 0; y < e.length; y++) {
                      var x = p.indexOf(n[y], a + 1), M = p.indexOf(t[y], a + 1);
                      if (u = x >= 0 && (M < 0 || x < M) ? x : M, u < 0)
                        continue e;
                      v = u - a - 1, v > 0 && (a === -1 && (s += 10), s += v, c = c | 1 << y), a = u;
                    }
                }
                l.matchMask = c, l.exactMatch = s ? 0 : 1, l.$score = (l.score || 0) - s, i.push(l);
              }
            }
          return i;
        }, h;
      }()
    );
    C.Autocomplete = k, C.CompletionProvider = F, C.FilteredList = I;
  }), ace.define("ace/autocomplete/text_completer", ["require", "exports", "module", "ace/range"], function(g, C, V) {
    var _ = g("../range").Range, T = /[^a-zA-Z_0-9\$\-\u00C0-\u1FFF\u2C00-\uD7FF\w]+/;
    function R(d, m) {
      var S = d.getTextRange(_.fromPoints({
        row: 0,
        column: 0
      }, m));
      return S.split(T).length - 1;
    }
    function b(d, m) {
      var S = R(d, m), L = d.getValue().split(T), $ = /* @__PURE__ */ Object.create(null), N = L[S];
      return L.forEach(function(E, O) {
        if (!(!E || E === N)) {
          var k = Math.abs(S - O), F = L.length - k;
          $[E] ? $[E] = Math.max(F, $[E]) : $[E] = F;
        }
      }), $;
    }
    C.getCompletions = function(d, m, S, L, $) {
      var N = b(m, S), E = Object.keys(N);
      $(null, E.map(function(O) {
        return {
          caption: O,
          value: O,
          score: N[O],
          meta: "local"
        };
      }));
    };
  }), ace.define("ace/ext/language_tools", ["require", "exports", "module", "ace/snippets", "ace/autocomplete", "ace/config", "ace/lib/lang", "ace/autocomplete/util", "ace/autocomplete/text_completer", "ace/editor", "ace/config"], function(g, C, V) {
    var _ = g("../snippets").snippetManager, T = g("../autocomplete").Autocomplete, R = g("../config"), b = g("../lib/lang"), d = g("../autocomplete/util"), m = g("../autocomplete/text_completer"), S = {
      getCompletions: function(t, n, o, l, p) {
        if (n.$mode.completer)
          return n.$mode.completer.getCompletions(t, n, o, l, p);
        var a = t.session.getState(o.row), c = n.$mode.getCompletions(a, n, o, l);
        c = c.map(function(s) {
          return s.completerId = S.id, s;
        }), p(null, c);
      },
      id: "keywordCompleter"
    }, L = function(t) {
      var n = {};
      return t.replace(/\${(\d+)(:(.*?))?}/g, function(o, l, p, a) {
        return n[l] = a || "";
      }).replace(/\$(\d+?)/g, function(o, l) {
        return n[l];
      });
    }, $ = {
      getCompletions: function(t, n, o, l, p) {
        var a = [], c = n.getTokenAt(o.row, o.column);
        c && c.type.match(/(tag-name|tag-open|tag-whitespace|attribute-name|attribute-value)\.xml$/) ? a.push("html-tag") : a = _.getActiveScopes(t);
        var s = _.snippetMap, u = [];
        a.forEach(function(v) {
          for (var f = s[v] || [], y = f.length; y--; ) {
            var x = f[y], M = x.name || x.tabTrigger;
            M && u.push({
              caption: M,
              snippet: x.content,
              meta: x.tabTrigger && !x.name ? x.tabTrigger + "⇥ " : "snippet",
              completerId: $.id
            });
          }
        }, this), p(null, u);
      },
      getDocTooltip: function(t) {
        t.snippet && !t.docHTML && (t.docHTML = [
          "<b>",
          b.escapeHTML(t.caption),
          "</b>",
          "<hr></hr>",
          b.escapeHTML(L(t.snippet))
        ].join(""));
      },
      id: "snippetCompleter"
    }, N = [$, m, S];
    C.setCompleters = function(t) {
      N.length = 0, t && N.push.apply(N, t);
    }, C.addCompleter = function(t) {
      N.push(t);
    }, C.textCompleter = m, C.keyWordCompleter = S, C.snippetCompleter = $;
    var E = {
      name: "expandSnippet",
      exec: function(t) {
        return _.expandWithTab(t);
      },
      bindKey: "Tab"
    }, O = function(t, n) {
      k(n.session.$mode);
    }, k = function(t) {
      typeof t == "string" && (t = R.$modes[t]), t && (_.files || (_.files = {}), F(t.$id, t.snippetFileId), t.modes && t.modes.forEach(k));
    }, F = function(t, n) {
      !n || !t || _.files[t] || (_.files[t] = {}, R.loadModule(n, function(o) {
        o && (_.files[t] = o, !o.snippets && o.snippetText && (o.snippets = _.parseSnippetFile(o.snippetText)), _.register(o.snippets || [], o.scope), o.includeScopes && (_.snippetMap[o.scope].includeScopes = o.includeScopes, o.includeScopes.forEach(function(l) {
          k("ace/mode/" + l);
        })));
      }));
    }, I = function(t) {
      var n = t.editor, o = n.completer && n.completer.activated;
      if (t.command.name === "backspace")
        o && !d.getCompletionPrefix(n) && n.completer.detach();
      else if (t.command.name === "insertstring" && !o) {
        h = t;
        var l = t.editor.$liveAutocompletionDelay;
        l ? r.delay(l) : e(t);
      }
    }, h, r = b.delayedCall(function() {
      e(h);
    }, 0), e = function(t) {
      var n = t.editor, o = d.getCompletionPrefix(n), l = t.args, p = d.triggerAutocomplete(n, l);
      if (o && o.length >= n.$liveAutocompletionThreshold || p) {
        var a = T.for(n);
        a.autoShown = !0, a.showPopup(n);
      }
    }, i = g("../editor").Editor;
    g("../config").defineOptions(i.prototype, "editor", {
      enableBasicAutocompletion: {
        set: function(t) {
          t ? (this.completers || (this.completers = Array.isArray(t) ? t : N), this.commands.addCommand(T.startCommand)) : this.commands.removeCommand(T.startCommand);
        },
        value: !1
      },
      enableLiveAutocompletion: {
        set: function(t) {
          t ? (this.completers || (this.completers = Array.isArray(t) ? t : N), this.commands.on("afterExec", I)) : this.commands.off("afterExec", I);
        },
        value: !1
      },
      liveAutocompletionDelay: {
        initialValue: 0
      },
      liveAutocompletionThreshold: {
        initialValue: 0
      },
      enableSnippets: {
        set: function(t) {
          t ? (this.commands.addCommand(E), this.on("changeMode", O), O(null, this)) : (this.commands.removeCommand(E), this.off("changeMode", O));
        },
        value: !1
      }
    });
  }), function() {
    ace.require(["ace/ext/language_tools"], function(g) {
      X && (X.exports = g);
    });
  }();
})(Y);
