import { __module as p } from "../../../_virtual/mode-json.ts";
(function(v, x) {
  ace.define("ace/mode/json_highlight_rules", ["require", "exports", "module", "ace/lib/oop", "ace/mode/text_highlight_rules"], function(l, d, k) {
    var u = l("../lib/oop"), h = l("./text_highlight_rules").TextHighlightRules, c = function() {
      this.$rules = {
        start: [
          {
            token: "variable",
            // single line
            regex: '["](?:(?:\\\\.)|(?:[^"\\\\]))*?["]\\s*(?=:)'
          },
          {
            token: "string",
            // single line
            regex: '"',
            next: "string"
          },
          {
            token: "constant.numeric",
            // hex
            regex: "0[xX][0-9a-fA-F]+\\b"
          },
          {
            token: "constant.numeric",
            // float
            regex: "[+-]?\\d+(?:(?:\\.\\d*)?(?:[eE][+-]?\\d+)?)?\\b"
          },
          {
            token: "constant.language.boolean",
            regex: "(?:true|false)\\b"
          },
          {
            token: "text",
            // single quoted strings are not allowed
            regex: "['](?:(?:\\\\.)|(?:[^'\\\\]))*?[']"
          },
          {
            token: "comment",
            // comments are not allowed, but who cares?
            regex: "\\/\\/.*$"
          },
          {
            token: "comment.start",
            // comments are not allowed, but who cares?
            regex: "\\/\\*",
            next: "comment"
          },
          {
            token: "paren.lparen",
            regex: "[[({]"
          },
          {
            token: "paren.rparen",
            regex: "[\\])}]"
          },
          {
            token: "punctuation.operator",
            regex: /[,]/
          },
          {
            token: "text",
            regex: "\\s+"
          }
        ],
        string: [
          {
            token: "constant.language.escape",
            regex: /\\(?:x[0-9a-fA-F]{2}|u[0-9a-fA-F]{4}|["\\\/bfnrt])/
          },
          {
            token: "string",
            regex: '"|$',
            next: "start"
          },
          {
            defaultToken: "string"
          }
        ],
        comment: [
          {
            token: "comment.end",
            // comments are not allowed, but who cares?
            regex: "\\*\\/",
            next: "start"
          },
          {
            defaultToken: "comment"
          }
        ]
      };
    };
    u.inherits(c, h), d.JsonHighlightRules = c;
  }), ace.define("ace/mode/matching_brace_outdent", ["require", "exports", "module", "ace/range"], function(l, d, k) {
    var u = l("../range").Range, h = function() {
    };
    (function() {
      this.checkOutdent = function(c, s) {
        return /^\s+$/.test(c) ? /^\s*\}/.test(s) : !1;
      }, this.autoOutdent = function(c, s) {
        var e = c.getLine(s), i = e.match(/^(\s*\})/);
        if (!i)
          return 0;
        var t = i[1].length, o = c.findMatchingBracket({ row: s, column: t });
        if (!o || o.row == s)
          return 0;
        var n = this.$getIndent(c.getLine(o.row));
        c.replace(new u(s, 0, s, t - 1), n);
      }, this.$getIndent = function(c) {
        return c.match(/^\s*/)[0];
      };
    }).call(h.prototype), d.MatchingBraceOutdent = h;
  }), ace.define("ace/mode/folding/cstyle", ["require", "exports", "module", "ace/lib/oop", "ace/range", "ace/mode/folding/fold_mode"], function(l, d, k) {
    var u = l("../../lib/oop"), h = l("../../range").Range, c = l("./fold_mode").FoldMode, s = d.FoldMode = function(e) {
      e && (this.foldingStartMarker = new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/, "|" + e.start)), this.foldingStopMarker = new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/, "|" + e.end)));
    };
    u.inherits(s, c), (function() {
      this.foldingStartMarker = /([\{\[\(])[^\}\]\)]*$|^\s*(\/\*)/, this.foldingStopMarker = /^[^\[\{\(]*([\}\]\)])|^[\s\*]*(\*\/)/, this.singleLineBlockCommentRe = /^\s*(\/\*).*\*\/\s*$/, this.tripleStarBlockCommentRe = /^\s*(\/\*\*\*).*\*\/\s*$/, this.startRegionRe = /^\s*(\/\*|\/\/)#?region\b/, this._getFoldWidgetBase = this.getFoldWidget, this.getFoldWidget = function(e, i, t) {
        var o = e.getLine(t);
        if (this.singleLineBlockCommentRe.test(o) && !this.startRegionRe.test(o) && !this.tripleStarBlockCommentRe.test(o))
          return "";
        var n = this._getFoldWidgetBase(e, i, t);
        return !n && this.startRegionRe.test(o) ? "start" : n;
      }, this.getFoldWidgetRange = function(e, i, t, o) {
        var n = e.getLine(t);
        if (this.startRegionRe.test(n))
          return this.getCommentRegionBlock(e, n, t);
        var r = n.match(this.foldingStartMarker);
        if (r) {
          var a = r.index;
          if (r[1])
            return this.openingBracketBlock(e, r[1], t, a);
          var g = e.getCommentFoldRange(t, a + r[0].length, 1);
          return g && !g.isMultiLine() && (o ? g = this.getSectionRange(e, t) : i != "all" && (g = null)), g;
        }
        if (i !== "markbegin") {
          var r = n.match(this.foldingStopMarker);
          if (r) {
            var a = r.index + r[0].length;
            return r[1] ? this.closingBracketBlock(e, r[1], t, a) : e.getCommentFoldRange(t, a, -1);
          }
        }
      }, this.getSectionRange = function(e, i) {
        var t = e.getLine(i), o = t.search(/\S/), n = i, a = t.length;
        i = i + 1;
        for (var g = i, r = e.getLength(); ++i < r; ) {
          t = e.getLine(i);
          var m = t.search(/\S/);
          if (m !== -1) {
            if (o > m)
              break;
            var f = this.getFoldWidgetRange(e, "all", i);
            if (f) {
              if (f.start.row <= n)
                break;
              if (f.isMultiLine())
                i = f.end.row;
              else if (o == m)
                break;
            }
            g = i;
          }
        }
        return new h(n, a, g, e.getLine(g).length);
      }, this.getCommentRegionBlock = function(e, i, t) {
        for (var o = i.search(/\s*$/), n = e.getLength(), a = t, g = /^\s*(?:\/\*|\/\/|--)#?(end)?region\b/, r = 1; ++t < n; ) {
          i = e.getLine(t);
          var m = g.exec(i);
          if (m && (m[1] ? r-- : r++, !r))
            break;
        }
        var f = t;
        if (f > a)
          return new h(a, o, f, i.length);
      };
    }).call(s.prototype);
  }), ace.define("ace/mode/json", ["require", "exports", "module", "ace/lib/oop", "ace/mode/text", "ace/mode/json_highlight_rules", "ace/mode/matching_brace_outdent", "ace/mode/folding/cstyle", "ace/worker/worker_client"], function(l, d, k) {
    var u = l("../lib/oop"), h = l("./text").Mode, c = l("./json_highlight_rules").JsonHighlightRules, s = l("./matching_brace_outdent").MatchingBraceOutdent, e = l("./folding/cstyle").FoldMode, i = l("../worker/worker_client").WorkerClient, t = function() {
      this.HighlightRules = c, this.$outdent = new s(), this.$behaviour = this.$defaultBehaviour, this.foldingRules = new e();
    };
    u.inherits(t, h), (function() {
      this.lineCommentStart = "//", this.blockComment = { start: "/*", end: "*/" }, this.getNextLineIndent = function(o, n, a) {
        var g = this.$getIndent(n);
        if (o == "start") {
          var r = n.match(/^.*[\{\(\[]\s*$/);
          r && (g += a);
        }
        return g;
      }, this.checkOutdent = function(o, n, a) {
        return this.$outdent.checkOutdent(n, a);
      }, this.autoOutdent = function(o, n, a) {
        this.$outdent.autoOutdent(n, a);
      }, this.createWorker = function(o) {
        var n = new i(["ace"], "ace/mode/json_worker", "JsonWorker");
        return n.attachToDocument(o.getDocument()), n.on("annotate", function(a) {
          o.setAnnotations(a.data);
        }), n.on("terminate", function() {
          o.clearAnnotations();
        }), n;
      }, this.$id = "ace/mode/json";
    }).call(t.prototype), d.Mode = t;
  }), function() {
    ace.require(["ace/mode/json"], function(l) {
      v && (v.exports = l);
    });
  }();
})(p);
