import o from "../ace-builds/src-noconflict/ace.ts";
import { defineComponent as s, h as r, markRaw as a, capitalize as h } from "vue";
import d from "../resize-observer-polyfill/dist/ResizeObserver.es.ts";
const i = [
  "blur",
  "input",
  "change",
  "changeSelectionStyle",
  "changeSession",
  "copy",
  "focus",
  "paste"
], m = s({
  name: "VAceEditor",
  props: {
    value: {
      type: String,
      required: !0
    },
    lang: {
      type: String,
      default: "text"
    },
    theme: {
      type: String,
      default: "chrome"
    },
    options: Object,
    placeholder: String,
    readonly: Boolean,
    wrap: Boolean,
    printMargin: {
      type: [Boolean, Number],
      default: !0
    },
    minLines: Number,
    maxLines: Number
  },
  emits: ["update:value", "init", ...i],
  render() {
    return r("div");
  },
  mounted() {
    const e = this._editor = a(o.edit(this.$el, {
      placeholder: this.placeholder,
      readOnly: this.readonly,
      value: this.value,
      mode: "ace/mode/" + this.lang,
      theme: "ace/theme/" + this.theme,
      wrap: this.wrap,
      printMargin: this.printMargin,
      useWorker: !1,
      minLines: this.minLines,
      maxLines: this.maxLines,
      ...this.options
    }));
    this._contentBackup = this.value, this._isSettingContent = !1, e.on("change", () => {
      if (this._isSettingContent)
        return;
      const t = e.getValue();
      this._contentBackup = t, this.$emit("update:value", t);
    }), i.forEach((t) => {
      const n = "on" + h(t);
      typeof this.$.vnode.props[n] == "function" && e.on(t, this.$emit.bind(this, t));
    }), this._ro = new d(() => e.resize()), this._ro.observe(this.$el), this.$emit("init", e);
  },
  beforeUnmount() {
    var e, t;
    (e = this._ro) === null || e === void 0 || e.disconnect(), (t = this._editor) === null || t === void 0 || t.destroy();
  },
  methods: {
    focus() {
      this._editor.focus();
    },
    blur() {
      this._editor.blur();
    },
    selectAll() {
      this._editor.selectAll();
    },
    getAceInstance() {
      return this._editor;
    }
  },
  watch: {
    value(e) {
      if (this._contentBackup !== e) {
        try {
          this._isSettingContent = !0, this._editor.setValue(e, 1);
        } finally {
          this._isSettingContent = !1;
        }
        this._contentBackup = e;
      }
    },
    theme(e) {
      this._editor.setTheme("ace/theme/" + e);
    },
    options(e) {
      this._editor.setOptions(e);
    },
    readonly(e) {
      this._editor.setReadOnly(e);
    },
    placeholder(e) {
      this._editor.setOption("placeholder", e);
    },
    wrap(e) {
      this._editor.setWrapBehavioursEnabled(e);
    },
    printMargin(e) {
      this._editor.setOption("printMargin", e);
    },
    lang(e) {
      this._editor.setOption("mode", "ace/mode/" + e);
    },
    minLines(e) {
      this._editor.setOption("minLines", e);
    },
    maxLines(e) {
      this._editor.setOption("maxLines", e);
    }
  }
});
export {
  m as VAceEditor
};
