import o from "../Xhttp.ts";
import { FORM_DATA_URL as n } from "../url.ts";
import { F as i } from "../../../node_modules/file-saver/dist/FileSaver.min.ts";
import { message as d } from "ant-design-vue";
const u = {
  /**
   * 表单数据查询接口
   * @param {*} formName 表名
   * @param {*} param 查询参数
   * @returns
   */
  async searchFormData(a, t) {
    return await o.post(n.SEARCH(a), t);
  },
  /**
   * 表单数据添加接口
   * @param {*} formName 表名
   * @param {*} formData 表单数据
   * @returns
   */
  async addFormData(a, t) {
    return await o.post(n.ADD(a), t);
  },
  /**
   * 表单数据批量添加接口
   * @param {*} formName 表名
   * @param {*} formData 表单数据
   * @returns
   */
  async batchAddFormData(a, t) {
    return await o.post(n.BATCH(a), t);
  },
  /**
   * 关联表单数据查询
   * @param {*} formName 表名
   * @param {*} param 查询参数
   * @returns
   */
  async joinSearchFormData(a, t) {
    return await o.post(n.JOIN_SEARCH(a), t);
  },
  /**
   * 表单数据查询单条
   * @param {*} formName 表名
   * @param {*} id 单条数据id
   * @param {*} resolveObj 是否翻译字典和显示子表
   * @returns
   */
  async searchFormDataById(a, t, r) {
    const e = (r == null ? void 0 : r.resolveDic) || !1, s = (r == null ? void 0 : r.resolveSubItems) || !1;
    return await o.get(n.SEARCH_BY_ID(a, t, e, s));
  },
  /**
   * 表单数据删除
   * @param {*} formName 表名
   * @param {*} id 单条数据id
   * @returns
   */
  async deleteFormDataById(a, t) {
    return await o.delete(n.DELETE_BY_ID(a, t));
  },
  /**
   * 表单数据批量删除
   * @param {*} formName 表名
   * @param {*} ids 数据id数组
   * @returns
   */
  async bathDeleteFormData(a, t) {
    return await o.delete(n.BATCH(a), {
      data: { dataIds: t }
    });
  },
  /**
   * 表单数据更新接口
   * @param {*} formName 表名
   * @param {*} id 单条数据id
   * @returns
   */
  async updateFormData(a, t) {
    return await o.put(n.UPDATE(a), t);
  },
  /**
   * 导入表单数据
   * @param {*} formName 表名
   * @param {*} file 导入文件
   * @returns
   */
  async importFormData(a, t) {
    const r = new FormData();
    return r.append("file", t), await o.post(n.IMPORT(a), r);
  },
  /**
   * 表单数据更新状态接口
   * @param {*} formName 表名
   * @param {*} dataId 单条数据id
   * @param {*} formData 参数
   * @returns
   */
  async updateState(a, t, r) {
    return await o.put(n.UPDATE_STATE(a, t), r);
  },
  /**
   * 表单数据批量修改状态
   * @param {*} formName 表名
   * @returns
   */
  async batchUpdateState(a, t) {
    return await o.post(n.BATCH_STATE(a), t);
  },
  /**
   * 表单数据根据过滤条件批量修改状态
   * @param {*} formName 表名
   * @returns
   */
  async filterBatchUpdateState(a, t) {
    return await o.post(n.BATCH_STATE_FILTER(a), t);
  },
  /**
   * 表单数据操作日志接口
   * @param {*} formName 表名
   * @param {*} dataId 单条数据id
   * @returns
   */
  async searchOperationLogs(a, t, r) {
    return await o.get(n.SEARCH_STATE(a, t, r));
  },
  /**
   * 表单数据统计
   * @param {*} formName 表名
   * @param {*} data
   * {
    "aggregates": [["农场类型", "count"]],
    "groupFields":["pcode"],
    "filter":["=", "农场类型", "种植"]
    }
   * @returns
   */
  async formDataCount(a, t) {
    return await o.post(n.COUNT(a), t);
  },
  /**
   * 表单数据下载
   * @param {string} name 文件名
   * @param {string} formName 表名称
   * @param {object} data 过滤条件
   */
  async dataDownload(a, t, r = {}) {
    return d.info(`开始下载：${a}`), o.postDownload(`form/${t}/download`, r).then((e) => {
      i.saveAs(e, a);
    });
  },
  /**
   * 导入数据（附带额外信息）
   * @param {string} formName 表名称
   * @param {file} file 上传Excel表格   表头为label   重复label使用spareLabel
   * @param {object} data 自带数据    key值为name
   * @param {array} fieldAssemble  数组 需要拼接参数  多个sourcefields 以delimiter为连接符组装，然后赋值给targetField
   *  示例 {"sourceFields":["field1","field2"],"delimiter":"-","targetField":"field3"}
   */
  async formexImport(a, t, r, e) {
    const s = new FormData();
    return s.append("file", t), r && s.append("data", JSON.stringify(r)), e && s.append("fieldAssemble", JSON.stringify(e)), o.post(`/formex/${a}/import`, s);
  },
  /**
   * 表单word下载
   * @param {string} formName 表名称
   * @param {object} data 表单数据 {"dataId": "数据id", "subForms": [{ "formName": "物料使用情况表"}]}
   * @param {string} name  下载word名称
   */
  async downloadWord(a, t, r) {
    return r || (r = `${a}.docx`), d.info(`开始下载：${r}`), o.getDownload(`/extend/word/${a}/download`, t).then((e) => {
      i.saveAs(e, r);
    });
  },
  /**
   * 表单pdf查看
   * @param {string} formName 表名称
   * @param {object} data 表单数据 {"dataId": "数据id", "subForms": [{ "formName": "物料使用情况表"}]}
   */
  viewPdfUrl(a, t) {
    const { dataId: r, subForms: e } = t;
    let s = `dataId=${r}`;
    return e && (s += `&subForms=${encodeURIComponent(JSON.stringify(e))}`), `/api/misengine/extend/pdf/${a}/download?${s}`;
  }
};
export {
  u as default
};
