import a from "../Xhttp.ts";
import { ROLE_URL as r } from "../url.ts";
const s = {
  /**
   * 查询当前用户授权菜单树
   */
  async queryAuthorizeTreeMenus() {
    return await a.get(r.MENU_TREE_LIST);
  },
  /**
   * 根据条件进行分页查询角色列表
   */
  async queryAllRole(t = {}) {
    return await a.get(r.LIST, t);
  },
  // 新增角色
  async addRole(t) {
    return await a.post(r.ADD, t);
  },
  // 更新角色
  async modifyRole(t, e) {
    return await a.put(r.MODIFY(t), e);
  },
  // 删除角色
  async deleteRole(t) {
    return await a.delete(r.DELETE(t));
  },
  /**
   * 获取表单授权的角色信息
   * @param {*} formId 表单ID
   * @returns
   */
  async getRoleFormList(t) {
    return await a.get(r.ROLE_FORM_LIST(t));
  },
  /**
   * 向角色授权表单
   * @param {*} roleId 角色ID
   * @param {*} formId 表单ID
   * @returns
   */
  async bindForm(t, e) {
    return await a.post(r.BIND_FORM(t), e);
  },
  /**
   * 向角色取消表单授权
   * @param {*} roleId 角色ID
   * @param {*} formId 表单ID
   * @returns
   */
  async unbindForm(t, e) {
    return await a.post(r.UNBIND_FORM(t), e);
  },
  // 获取被选中的规则的所有id
  async getDataRules(t, e) {
    return await a.get(r.DATA_RULE_LIST(t), {
      rule_table: e
    });
  },
  // 授权规则
  async bindDataRule(t, e) {
    return await a.post(r.BIND_DATA_RULE(t), e);
  },
  // 取消规则授权
  async unbindDataRule(t, e) {
    return await a.post(r.UNBIND_DATA_RULE(t), e);
  },
  /**
   * 查询角色菜单列表(把子树平铺)
   * @param {string} roleId 角色id
   */
  async queryAuthorizeMenus(t) {
    return await a.get(r.MENU_LIST(t), {});
  },
  /**
   * 角色授权菜单
   * @param {string} roleId 角色id
   * @param {array} menuIds 菜单id数组
   */
  async authorizeMenu(t, e) {
    return await a.post(r.AUTHORIZE_MENU(t), e);
  },
  /**
   * 角色取消授权菜单
   * @param {string} roleId 角色id
   * @param {array} menuIds 资源id数组
   */
  async revokeMenu(t, e) {
    return await a.post(r.REVOKE_MENU(t), e);
  },
  /**
   * 角色授权资源(接口）
   * @param {string} roleId 角色id
   * @param {array} resourceIds 资源id数组
   */
  async authorizeResource(t, e) {
    return await a.post(
      r.AUTHORIZE_RESOURCE(t),
      e
    );
  },
  /**
   * 角色取消授权资源（接口）
   * @param {string} roleId 角色id
   * @param {array} resourceIds 资源id数组
   */
  async revokeResource(t, e) {
    return await a.post(r.REVOKE_RESOURCE(t), e);
  },
  // 授权资源查询(接口)
  async authResource(t, e) {
    return await a.get(
      r.AUTH_RESOURCE(t),
      e
    );
  }
};
export {
  s as default
};
