const o = {
  LOGIN: "oauth/token",
  REGISTER: "user/register",
  RESET: "user/reset",
  LOGOUT: "oauth/logout"
}, _ = {
  IMAGE_CODE: "sms/getImgCode",
  SMS_REGISTER: "sms/register",
  SMS_RESET: "sms/reset"
}, U = {
  DELETE: (e) => `attachment/${e}`,
  STS_URL: "sts/getTempToken"
}, u = {
  RESOURCE_LIST: "resource",
  RULE_LIST: (e) => `resource/${e}/rule`,
  ADD_RULE: (e) => `resource/${e}/rule`,
  MODIFY_RULE: (e) => `resource/${e}/rule`,
  DELETE_RULE: (e) => `resource/rule/${e}`
}, s = {
  TREE_LIST: "menu/tree",
  ADD_MENU: "menu",
  UPDATE_MENU: (e) => `menu/${e}`,
  DELETE_MENU: (e) => `menu/${e}`
}, l = {
  LIST: "user",
  ADD_USER: "user",
  MODIFY_USER: (e) => `user/${e}`,
  SUSPEND_USER: (e) => `user/${e}/disable`,
  RESUME_USER: (e) => `user/${e}/enable`,
  DELETE_USER: (e) => `user/${e}`,
  // md5格式
  RESET_PASSWORD: "user/admin/resetPasswordMd5",
  // 普通格式
  // RESET_PASSWORD: "user/admin/resetPassword",
  OPERATIONS_URL: "login/search"
  // 用户运维列表
}, T = {
  LIST: "role",
  ADD: "role",
  MODIFY: (e) => `role/${e}`,
  DELETE: (e) => `role/${e}`,
  USER_LIST: (e) => `role/${e}/user`,
  BIND_USER: (e) => `role/${e}/user/bind`,
  UNBIND_USER: (e) => `role/${e}/user/unbind`,
  RESOURCES_LIST: (e) => `role/${e}/resource`,
  AUTHORIZE_RESOURCE: (e) => `role/${e}/resource/bind`,
  REVOKE_RESOURCE: (e) => `role/${e}/resource/unbind`,
  MENU_TREE_LIST: "menu/self/tree",
  MENU_TREE_ROLE_LIST: (e) => `/menu/${e}/tree`,
  MENU_LIST: (e) => `role/${e}/menu`,
  AUTHORIZE_MENU: (e) => `role/${e}/menu/bind`,
  REVOKE_MENU: (e) => `role/${e}/menu/unbind`,
  RESOURCE_RULE_LIST: (e, E) => `role/${e}/resource/${E}/rules`,
  AUTHORIZE_RESOURCE_RULE: (e) => `role/${e}/resource/rule/bind`,
  REVOKE_RESOURCE_RULE: (e) => `role/${e}/resource/rule/unbind`,
  AUTHORIZE_MENU_RULE: (e) => `role/${e}/menu/rule/bind`,
  REVOKE_MENU_RULE: (e) => `role/${e}/menu/rule/unbind`,
  MENU_RULE_LIST: (e, E) => `role/${e}/menu/${E}/rules`,
  BIND_FORM: (e) => `role/${e}/table/bind`,
  UNBIND_FORM: (e) => `role/${e}/table/unbind`,
  ROLE_FORM_LIST: (e) => `role/${e}/table`,
  FORM_ROLE_LIST: (e) => `resource/table/${e}/role`,
  DATA_RULE_LIST: (e) => `role/${e}/rule`,
  BIND_DATA_RULE: (e) => `role/${e}/rule/bind`,
  UNBIND_DATA_RULE: (e) => `role/${e}/rule/unbind`,
  AUTH: (e) => `role/${e}/table/bind`,
  AUTH_REVOKE: (e) => `role/${e}/table/unbind`,
  AUTH_SEARCH: (e) => `resource/table/${e}/role`,
  AUTH_RESOURCE: (e) => `/role/${e}/resource`
}, S = {
  QUERY: (e) => `formDesign/${e}`,
  DEPLOY: "formDesign",
  UPDATE: (e) => `formDesign/${e}`,
  SEARCH: "formDesign",
  DELETE: (e) => `formDesign/${e}?cascade=true`,
  FORM_IMPORT: "/table/import",
  FORM_EXPORT: "/table/export",
  RESOURCE_LIST: (e) => `/resource/table/${e}/role`,
  RESOURCE_BIND: (e) => `/resource/table/${e}/role/bind`,
  RESOURCE_UNBIND: (e) => `/resource/table/${e}/role/unbind`
}, $ = {
  ADD: (e) => `form/${e}`,
  SEARCH: (e) => `form/${e}/search`,
  JOIN_SEARCH: (e) => `form/${e}/joinSearch`,
  BATCH: (e) => `form/${e}/batch`,
  SEARCH_BY_ID: (e, E, r, R) => `form/${e}/${E}?resolveDic=${r}&resolveSubItems=${R}`,
  DELETE_BY_ID: (e, E) => `form/${e}/${E}`,
  SEARCH_STATE: (e, E, r) => `custom/form/${e}/${E}/log?field=${r}`,
  UPDATE_STATE: (e, E) => `custom/form/${e}/${E}/state`,
  BATCH_STATE: (e) => `custom/form/${e}/state/batchUpdate`,
  BATCH_STATE_FILTER: (e) => `custom/form/${e}/state/batchUpdateByFilter`,
  UPDATE: (e) => `form/${e}`,
  IMPORT: (e) => `form/${e}/import`,
  COUNT: (e) => `/form/${e}/aggregation`
}, t = {
  LIST: "dataRule",
  GET: (e) => `dataRule/${e}`,
  ADD: "dataRule",
  UPDATE: (e) => `dataRule/${e}`,
  DELETE: (e) => `dataRule/${e}`
};
export {
  t as DATA_RULE_URL,
  U as FILE_URL,
  $ as FORM_DATA_URL,
  S as FORM_DESIGN_URL,
  o as LOGIN_URL,
  s as MENU_URL,
  u as RESOURCE_URL,
  T as ROLE_URL,
  _ as SMS_URL,
  l as USER_URL
};
