import { defineComponent as me, ref as o, withAsyncContext as ge, computed as N, onMounted as be, resolveComponent as w, unref as a, openBlock as F, createBlock as H, withCtx as v, createCommentVNode as _, createElementVNode as ye, createVNode as O, isRef as he, createElementBlock as ve, Fragment as ke, createTextVNode as Y } from "vue";
import we from "../GTSearch/index.vue.ts";
import Fe from "../GTTable/index.vue.ts";
import b from "../../apis/formData/index.ts";
import _e from "./hooks/useOptions.ts";
import { toFrontFormData as Oe, toApiFormData as J } from "../../utils/form.ts";
import { testFormat as De } from "./hooks/methods.ts";
import { message as d, Modal as Ce } from "ant-design-vue";
import { keyBy as K, cloneDeep as P } from "lodash";
import { useRoute as xe } from "../../../node_modules/vue-router/dist/vue-router.ts";
const Ee = /* @__PURE__ */ me({
  name: "GTSearchTable",
  __name: "index",
  props: {
    tableOptions: { type: Object, required: !1 },
    formName: { type: String, required: !1 },
    showTitle: { type: Boolean, required: !1, default: !0 },
    yOffset: { type: Number, required: !1, default: 310 },
    searchListWidth: { type: Number, required: !1, default: 300 },
    operatorWidth: { type: Number, required: !1 },
    allowSelect: { type: Boolean, required: !1, default: !0 },
    customDicts: { type: Array, required: !1 },
    formTableOptionsHandler: { type: Function, required: !1 },
    beforeTableData: { type: Function, required: !1 },
    beforeSubmitHandler: { type: Function, required: !1 },
    beforeErrorMsg: { type: Function, required: !1 },
    initFilter: { type: Array, required: !1 }
  },
  emits: ["search-change", "operate"],
  async setup(X, { expose: Z, emit: ee }) {
    let k, A;
    const te = xe(), l = X, D = ee, R = o(), W = o(), z = o(), C = o(!1), y = o(!1), p = o(!1), B = o(0), x = o(0), m = o(""), S = o([]), s = o({
      page: {
        pageNum: 1,
        pageSize: 10
      },
      resolveSubItems: !0
    });
    Z({ getList: g, tableData: S });
    const {
      formOptions: c,
      dicts: E,
      searchFields: T,
      tableFields: M,
      groups: ae,
      recordOperators: G,
      tableOperators: L,
      outFields: q,
      defaultFields: re,
      regularFilter: V,
      formName: f,
      modalWidth: oe
    } = ([k, A] = ge(() => _e(l, te)), k = await k, A(), k), $ = N(() => l.showTitle ? c.formDef.title : ""), le = N(() => $.value ? l.yOffset + 50 + x.value : l.yOffset + x.value), U = N(() => {
      const t = {
        ...K(G.value, "key"),
        ...K(L.value, "key")
      };
      return m.value ? t[m.value].label + "数据" : "查看数据";
    }), se = (t) => {
      x.value = t;
    }, ie = async (t) => {
      try {
        const e = t.target.files[0];
        if (!De(e.name, ["xls", "xlsx", "xlsm"])) {
          d.warning("只能导入Excel表格！");
          return;
        }
        await b.importFormData(f, e), d.success("导入成功！"), g();
      } catch (e) {
        d.error(e.msg);
      }
      t.target.value = "";
    }, ne = (t) => {
      let { field: e, order: r } = t;
      if (e && r) {
        let n = { field: e, direction: r };
        s.value.orders = [n];
      } else
        delete s.value.orders;
      g();
    }, de = ({ key: t, data: e }) => {
      switch (t) {
        case "edit":
        case "readonly":
          I(t, e);
          break;
        case "delete":
          j([e._id]);
          break;
        default:
          D("operate", { key: t, data: e });
          break;
      }
    }, fe = ({ key: t, data: e }) => {
      if (t)
        switch (t) {
          case "add":
            I(t);
            break;
          case "download":
            ce(e);
            break;
          case "import":
            z.value.click();
            break;
          case "deletes":
            ue(e);
            break;
          default:
            D("operate", { key: t, data: e });
            break;
        }
    }, I = (t, e = {}) => {
      const r = e ? P(e) : "";
      c.formRecordData = Oe(r), m.value = t, c.readonly = t === "readonly", p.value = !0;
    }, ue = (t) => {
      t.length == 0 ? d.warning("请选择要删除的数据！") : Ce.confirm({
        title: "信息",
        content: "是否确定删除已选择的数据？",
        onOk() {
          j(t);
        },
        onCancel() {
        }
      });
    }, j = async (t) => {
      try {
        await b.bathDeleteFormData(f, t), g();
      } catch (e) {
        console.log("error :>> ", e), d.error(e.msg);
      }
    }, ce = (t) => {
      let e = {};
      t.length == 0 ? (e = P(s.value), delete e.page) : e = {
        filter: ["in", "_id", t]
      }, Array.isArray(q) && q.length != 0 && (e.outFields = q), e.resolveDic = !1, b.dataDownload(
        `${c.formDef.title || f}-填报数据.xlsx`,
        f,
        e
      );
    }, Q = (t) => {
      let e = [];
      t.map(({ name: r, value: n, operator: u }) => {
        let h = [];
        switch (u) {
          case "like":
            h = [u, r, `%${n}%`];
            break;
          default:
            h = [u, r, n];
            break;
        }
        e.push(h);
      }), V.length != 0 && e.push(...V), e.length > 1 ? e.unshift("and") : e = e.flat(1), s.value.filter = e, s.value.page.pageNum = 1, g();
    }, pe = async () => {
      y.value = !0;
      const t = await W.value.submit();
      if (t.state) {
        let e = t.data;
        if (typeof l.beforeSubmitHandler == "function" && (e = await l.beforeSubmitHandler(e, m.value)), typeof e > "u") {
          y.value = !1;
          return;
        }
        try {
          m.value == "add" ? await b.addFormData(f, J(e)) : (e._id = c.formRecordData._id, await b.updateFormData(f, J(e))), d.success(`${U.value}成功！`), await g(), p.value = !1;
        } catch ({ msg: r, data: n, code: u }) {
          if (typeof l.beforeErrorMsg == "function")
            l.beforeErrorMsg({ msg: r, data: n, code: u });
          else
            switch (u) {
              case 4011:
                d.error(`${n.fields}不能重复！`);
                break;
              default:
                d.error(r);
                break;
            }
        } finally {
          y.value = !1;
        }
      } else
        y.value = !1;
    };
    async function g() {
      if (f)
        try {
          C.value = !0;
          let t = await b.searchFormData(f, s.value);
          typeof l.beforeTableData == "function" && (t = await l.beforeTableData(t)), B.value = t.total, S.value = t.list;
        } catch (t) {
          d.error(t.msg);
        } finally {
          C.value = !1;
        }
    }
    return be(() => {
      T.length !== 0 ? R.value.submitHandler() : Q([]);
    }), (t, e) => {
      const r = w("a-button"), n = w("GTForm"), u = w("a-modal"), h = w("a-card");
      return a(c).formDef ? (F(), H(h, {
        key: 0,
        class: "card-max",
        title: a($)
      }, {
        default: v(() => [
          a(T).length != 0 ? (F(), H(we, {
            key: 0,
            ref_key: "search_box",
            ref: R,
            listWidth: t.searchListWidth,
            fields: a(T),
            onSearch: Q,
            onChange: e[0] || (e[0] = (i) => D("search-change", i)),
            defaultFields: a(re),
            dicts: a(E),
            onAddHeight: se
          }, null, 8, ["listWidth", "fields", "defaultFields", "dicts"])) : _("", !0),
          ye("input", {
            type: "file",
            ref_key: "import_file",
            ref: z,
            onInput: e[1] || (e[1] = (i) => ie(i)),
            accept: "application/vnd.ms-excel,application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
            style: { display: "none" }
          }, null, 544),
          a(M).length != 0 ? (F(), H(Fe, {
            key: 1,
            fields: a(M),
            data: a(S),
            recordOperators: a(G),
            tableOperators: a(L),
            onTableOperatorClick: fe,
            onRecordOperatorClick: de,
            pageCurrent: a(s).page.pageNum,
            "onUpdate:pageCurrent": e[2] || (e[2] = (i) => a(s).page.pageNum = i),
            pageSize: a(s).page.pageSize,
            "onUpdate:pageSize": e[3] || (e[3] = (i) => a(s).page.pageSize = i),
            total: a(B),
            dicts: a(E),
            groups: a(ae),
            allowSelect: t.allowSelect,
            keyField: "_id",
            yOffset: a(le),
            loading: a(C),
            operatorWidth: t.operatorWidth,
            onRefresh: ne
          }, null, 8, ["fields", "data", "recordOperators", "tableOperators", "pageCurrent", "pageSize", "total", "dicts", "groups", "allowSelect", "yOffset", "loading", "operatorWidth"])) : _("", !0),
          O(u, {
            open: a(p),
            "onUpdate:open": e[5] || (e[5] = (i) => he(p) ? p.value = i : null),
            title: a(U),
            maskClosable: !1,
            destroyOnClose: "",
            width: a(oe),
            getContainer: ".card-max",
            class: "form-modal-box"
          }, {
            footer: v(() => [
              a(m) !== "readonly" ? (F(), ve(ke, { key: 0 }, [
                O(r, {
                  key: "back",
                  onClick: e[4] || (e[4] = (i) => p.value = !1)
                }, {
                  default: v(() => [
                    Y("取消")
                  ]),
                  _: 1
                }),
                O(r, {
                  key: "submit",
                  type: "primary",
                  loading: a(y),
                  onClick: pe
                }, {
                  default: v(() => [
                    Y("确认")
                  ]),
                  _: 1
                }, 8, ["loading"])
              ], 64)) : _("", !0)
            ]),
            default: v(() => [
              O(n, {
                ref_key: "gt_form",
                ref: W,
                options: a(c)
              }, null, 8, ["options"])
            ]),
            _: 1
          }, 8, ["open", "title", "width"])
        ]),
        _: 1
      }, 8, ["title"])) : _("", !0);
    };
  }
});
export {
  Ee as default
};
