import { defineComponent as E, ref as d, reactive as T, readonly as B, resolveComponent as v, openBlock as G, createElementBlock as P, createElementVNode as u, withKeys as Z, createVNode as o, unref as t, withCtx as r, createTextVNode as y, toDisplayString as H, isRef as J, normalizeStyle as W, nextTick as j, pushScopeId as M, popScopeId as Q } from "vue";
import { message as _ } from "ant-design-vue";
import { STATUS as X } from "../../types.ts";
import Y from "../../../../apis/login/index.ts";
import U from "../../../../apis/sms/index.ts";
const N = (C) => (M("data-v-820c4a5d"), C = C(), Q(), C), ee = { class: "login-wrapper" }, oe = /* @__PURE__ */ N(() => /* @__PURE__ */ u("div", { class: "title" }, "欢迎注册", -1)), te = { class: "submit" }, ae = { class: "link-wrapper" }, re = { class: "img-verify-code-content" }, se = /* @__PURE__ */ N(() => /* @__PURE__ */ u("h3", null, "请输入验证码", -1)), ie = { class: "img-wrapper" }, le = 180, me = /* @__PURE__ */ E({
  __name: "index",
  emits: ["update:status"],
  setup(C, { emit: O }) {
    const s = d({
      username: "",
      password: "",
      phone: "",
      verifyCode: ""
    }), n = T({
      loading: !1,
      verifyCodeDisabled: !1,
      modelVisible: !1,
      getVerifyCodeText: "获取验证码"
    }), A = B({
      username: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入用户名"
        },
        {
          trigger: "blur",
          pattern: /^[a-zA-Z0-9]{4,10}$/,
          message: "用户名4到16位，由数字和字母组成"
        }
      ],
      password: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入密码"
        },
        {
          trigger: "blur",
          pattern: /^.*(?=.{6,16})(?=.*\d)(?=.*[A-Z])(?=.*[a-z]).*$/,
          message: "密码6到16位，包含数字和大小写字母"
        }
      ],
      phone: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入手机号码"
        },
        {
          trigger: "blur",
          pattern: /^1(3[0-9]|4[5,7]|5[0,1,2,3,5,6,7,8,9]|6[2,5,6,7]|7[0,1,2,3,5,6,7,8]|8[0-9]|9[1,5,8,9])\d{8}$/,
          message: "请输入正确的手机号码"
        }
      ],
      verifyCode: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入验证码"
        }
      ]
    }), w = d(), D = O, x = () => {
      var a;
      (a = w.value) == null || a.validate().then(async (e) => {
        n.loading = !0;
        try {
          const { username: i, password: f, phone: c, verifyCode: m } = e;
          if (!await Y.register(i, i, f, c, m))
            return;
          _.success("注册成功"), s.value = {
            username: "",
            password: "",
            phone: "",
            verifyCode: ""
          };
        } catch (i) {
          _.error(i.msg);
        } finally {
          n.loading = !1;
        }
      });
    }, $ = {
      imgVerifyCode: [
        {
          required: !0,
          message: "请输入验证码"
        }
      ]
    }, b = d(!1), I = d(""), S = d(""), p = d(!1), R = d(), h = d(), g = T({
      imgVerifyCode: ""
    }), q = () => {
      var a;
      (a = w.value) == null || a.validateFields("phone").then(async () => {
        p.value = !0, k(), j(() => {
          var e;
          (e = h.value) == null || e.focus();
        });
      });
    }, k = async () => {
      const a = await U.getImageCode();
      a && (I.value = a.imgKey, S.value = a.base64);
    }, L = () => {
      p.value = !1;
    }, F = () => {
      var a;
      (a = R.value) == null || a.validateFields().then(
        async () => {
          var e;
          b.value = !0;
          try {
            await U.getResetPasswdSmsCode(
              s.value.phone,
              I.value,
              g.imgVerifyCode
            ), _.success("短信验证码已发送"), p.value = !1, K();
          } catch (i) {
            _.error(`验证码错误：${i.msg || "未知错误"}`), k(), g.imgVerifyCode = "", (e = h.value) == null || e.focus();
          } finally {
            b.value = !1;
          }
        },
        (e) => {
          _.error(JSON.stringify(e));
        }
      );
    }, K = () => {
      g.imgVerifyCode = "", n.verifyCodeDisabled = !0;
      let a = le;
      const e = setInterval(() => {
        n.getVerifyCodeText = `${a}秒后重新获取`, a -= 1, a === 0 && (n.getVerifyCodeText = "获取验证码", n.verifyCodeDisabled = !1, clearInterval(e));
      }, 1e3);
    };
    return (a, e) => {
      const i = v("svg-icon"), f = v("a-input"), c = v("a-form-item"), m = v("a-button"), V = v("a-form"), z = v("a-modal");
      return G(), P("div", ee, [
        oe,
        u("div", {
          class: "body",
          onKeydown: Z(x, ["enter"])
        }, [
          o(V, {
            model: t(s),
            ref_key: "registerRef",
            ref: w,
            rules: t(A)
          }, {
            default: r(() => [
              o(c, { name: "username" }, {
                default: r(() => [
                  o(f, {
                    value: t(s).username,
                    "onUpdate:value": e[0] || (e[0] = (l) => t(s).username = l),
                    class: "input-item",
                    allowClear: "",
                    placeholder: "用户名4到16位，由数字和字母组成"
                  }, {
                    prefix: r(() => [
                      o(i, { icon: "UserOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              }),
              o(c, { name: "password" }, {
                default: r(() => [
                  o(f, {
                    type: "password",
                    value: t(s).password,
                    "onUpdate:value": e[1] || (e[1] = (l) => t(s).password = l),
                    allowClear: "",
                    class: "input-item",
                    placeholder: "密码6到16位，包含数字和大小写字母"
                  }, {
                    prefix: r(() => [
                      o(i, { icon: "LockOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              }),
              o(c, { name: "phone" }, {
                default: r(() => [
                  o(f, {
                    maxLength: "11",
                    value: t(s).phone,
                    "onUpdate:value": e[2] || (e[2] = (l) => t(s).phone = l),
                    class: "input-item",
                    allowClear: "",
                    placeholder: "手机号码"
                  }, {
                    prefix: r(() => [
                      o(i, { icon: "PhoneOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              }),
              o(c, { name: "verifyCode" }, {
                default: r(() => [
                  o(f, {
                    value: t(s).verifyCode,
                    "onUpdate:value": e[3] || (e[3] = (l) => t(s).verifyCode = l),
                    class: "input-item verify-code",
                    placeholder: "验证码"
                  }, {
                    prefix: r(() => [
                      o(i, { icon: "LockOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"]),
                  o(m, {
                    class: "btn-verify-code",
                    type: "link",
                    loading: t(b),
                    onClick: q,
                    disabled: t(n).verifyCodeDisabled
                  }, {
                    default: r(() => [
                      y(H(t(n).getVerifyCodeText), 1)
                    ]),
                    _: 1
                  }, 8, ["loading", "disabled"])
                ]),
                _: 1
              }),
              u("div", te, [
                o(m, {
                  type: "primary",
                  block: "",
                  onClick: x,
                  class: "input-item",
                  loading: t(n).loading
                }, {
                  default: r(() => [
                    y(" 注册 ")
                  ]),
                  _: 1
                }, 8, ["loading"])
              ]),
              u("div", ae, [
                o(m, {
                  class: "btn-forget-passwd",
                  type: "link",
                  onClick: e[4] || (e[4] = () => D("update:status", t(X).SIGNING))
                }, {
                  default: r(() => [
                    y("立即登录")
                  ]),
                  _: 1
                })
              ])
            ]),
            _: 1
          }, 8, ["model", "rules"]),
          o(z, {
            class: "img-verify-code-wrapper",
            open: t(p),
            "onUpdate:open": e[6] || (e[6] = (l) => J(p) ? p.value = l : null),
            footer: null,
            onCancel: L
          }, {
            default: r(() => [
              u("div", re, [
                se,
                u("div", ie, [
                  u("img", {
                    class: "img-verify-code",
                    style: W({ "background-image": `url(${t(S)})` })
                  }, null, 4),
                  o(m, {
                    class: "btn-change-code",
                    type: "link",
                    onClick: k
                  }, {
                    default: r(() => [
                      y("看不清，换一个")
                    ]),
                    _: 1
                  })
                ]),
                o(V, {
                  ref_key: "codeFormRef",
                  ref: R,
                  model: t(g),
                  rules: $
                }, {
                  default: r(() => [
                    o(c, {
                      class: "input-img-code",
                      name: "imgVerifyCode"
                    }, {
                      default: r(() => [
                        o(f, {
                          ref_key: "verifyInputRef",
                          ref: h,
                          value: t(g).imgVerifyCode,
                          "onUpdate:value": e[5] || (e[5] = (l) => t(g).imgVerifyCode = l),
                          maxLength: 4,
                          allowClear: !0,
                          placeholder: "验证码"
                        }, null, 8, ["value"])
                      ]),
                      _: 1
                    }),
                    o(m, {
                      type: "primary",
                      block: "",
                      onClick: F,
                      class: "input-item",
                      loading: t(b)
                    }, {
                      default: r(() => [
                        y(" 确定 ")
                      ]),
                      _: 1
                    }, 8, ["loading"])
                  ]),
                  _: 1
                }, 8, ["model"])
              ])
            ]),
            _: 1
          }, 8, ["open"])
        ], 32)
      ]);
    };
  }
});
export {
  me as default
};
