import { defineComponent as G, ref as l, readonly as S, reactive as T, resolveComponent as g, openBlock as K, createElementBlock as Z, createElementVNode as u, createVNode as o, unref as r, withCtx as s, createTextVNode as y, toDisplayString as j, isRef as H, normalizeStyle as J, nextTick as W, pushScopeId as M, popScopeId as Q } from "vue";
import { STATUS as X } from "../../types.ts";
import N from "../../../../apis/sms/index.ts";
import { message as _ } from "ant-design-vue";
import Y from "../../../../apis/login/index.ts";
const O = (C) => (M("data-v-7c9942ec"), C = C(), Q(), C), ee = { class: "login-wrapper" }, oe = /* @__PURE__ */ O(() => /* @__PURE__ */ u("div", { class: "title" }, "重置密码", -1)), re = { class: "body" }, te = { class: "submit" }, se = { class: "link-wrapper" }, ae = { class: "img-verify-code-content" }, ie = /* @__PURE__ */ O(() => /* @__PURE__ */ u("h3", null, "请输入验证码", -1)), le = { class: "img-wrapper" }, ne = 180, ve = /* @__PURE__ */ G({
  __name: "index",
  emits: ["update:status"],
  setup(C, { emit: U }) {
    const A = U, b = l(!1), a = l({
      phone: "",
      verifyCode: "",
      password: "",
      confirmPassword: ""
    }), D = S({
      phone: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入手机号码"
        },
        {
          trigger: "blur",
          pattern: /^1(3[0-9]|4[5,7]|5[0,1,2,3,5,6,7,8,9]|6[2,5,6,7]|7[0,1,2,3,5,6,7,8]|8[0-9]|9[1,5,8,9])\d{8}$/,
          message: "请输入正确的手机号码"
        }
      ],
      verifyCode: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入验证码"
        }
      ],
      password: [
        {
          trigger: "blur",
          required: !0,
          message: "请输入密码"
        },
        {
          trigger: "blur",
          pattern: /^.*(?=.{6,16})(?=.*\d)(?=.*[A-Z])(?=.*[a-z]).*$/,
          message: "密码6到16位，包含数字和大小写字母"
        }
      ],
      confirmPassword: [
        {
          trigger: "blur",
          required: !0,
          message: "请输再次输入密码"
        },
        {
          trigger: "blur",
          pattern: /^.*(?=.{6,16})(?=.*\d)(?=.*[A-Z])(?=.*[a-z]).*$/,
          message: "密码6到16位，包含数字和大小写字母"
        },
        {
          trigger: "blur",
          validator: async (t, e) => e !== a.value.password ? Promise.reject("两次输入的密码不一致") : Promise.resolve()
        }
      ]
    }), h = l(), I = l(), w = l(), k = l(!1), m = l(!1), x = l(""), P = l(""), p = T({
      loading: !1,
      verifyCodeDisabled: !1,
      modelVisible: !1,
      getVerifyCodeText: "获取验证码"
    }), v = T({
      imgVerifyCode: ""
    }), $ = S({
      imgVerifyCode: [
        {
          required: !0,
          message: "请输入验证码"
        }
      ]
    }), V = async () => {
      const t = await N.getImageCode();
      t && (x.value = t.imgKey, P.value = t.base64);
    }, q = () => {
      m.value = !1;
    }, F = () => {
      var t;
      (t = h.value) == null || t.validateFields("phone").then(async () => {
        m.value = !0, V(), W(() => {
          var e;
          (e = w.value) == null || e.focus();
        });
      });
    }, L = () => {
      var t;
      (t = I.value) == null || t.validateFields().then(
        async () => {
          var e;
          k.value = !0;
          try {
            await N.getResetPasswdSmsCode(
              a.value.phone,
              x.value,
              v.imgVerifyCode
            ), _.success("短信验证码已发送"), m.value = !1, z();
          } catch (n) {
            _.error(`验证码错误：${n.msg || "未知错误"}`), V(), v.imgVerifyCode = "", (e = w.value) == null || e.focus();
          } finally {
            k.value = !1;
          }
        },
        (e) => {
          _.error(JSON.stringify(e));
        }
      );
    }, z = () => {
      v.imgVerifyCode = "", p.verifyCodeDisabled = !0;
      let t = ne;
      const e = setInterval(() => {
        p.getVerifyCodeText = `${t}秒后重新获取`, t -= 1, t === 0 && (p.getVerifyCodeText = "获取验证码", p.verifyCodeDisabled = !1, clearInterval(e));
      }, 1e3);
    }, E = () => {
      var t;
      (t = h.value) == null || t.validate().then(async (e) => {
        b.value = !0;
        const { phone: n, verifyCode: f, password: c } = e;
        try {
          if (!await Y.resetPassword(n, f, c))
            return;
          _.success("重置密码成功"), a.value = {
            phone: "",
            verifyCode: "",
            password: "",
            confirmPassword: ""
          };
        } catch (d) {
          _.error(d.msg);
        } finally {
          b.value = !1;
        }
      });
    };
    return (t, e) => {
      const n = g("svg-icon"), f = g("a-input"), c = g("a-form-item"), d = g("a-button"), R = g("a-form"), B = g("a-modal");
      return K(), Z("div", ee, [
        oe,
        u("div", re, [
          o(R, {
            model: r(a),
            ref_key: "resetPwdRef",
            ref: h,
            rules: r(D)
          }, {
            default: s(() => [
              o(c, { name: "phone" }, {
                default: s(() => [
                  o(f, {
                    value: r(a).phone,
                    "onUpdate:value": e[0] || (e[0] = (i) => r(a).phone = i),
                    class: "input-item",
                    allowClear: "",
                    placeholder: "手机号码"
                  }, {
                    prefix: s(() => [
                      o(n, { icon: "PhoneOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              }),
              o(c, { name: "verifyCode" }, {
                default: s(() => [
                  o(f, {
                    ref_key: "verifyInputRef",
                    ref: w,
                    value: r(a).verifyCode,
                    "onUpdate:value": e[1] || (e[1] = (i) => r(a).verifyCode = i),
                    class: "input-item verify-code",
                    placeholder: "验证码"
                  }, {
                    prefix: s(() => [
                      o(n, { icon: "NumberOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"]),
                  o(d, {
                    class: "btn-verify-code",
                    type: "link",
                    onClick: F,
                    disabled: r(p).verifyCodeDisabled
                  }, {
                    default: s(() => [
                      y(j(r(p).getVerifyCodeText), 1)
                    ]),
                    _: 1
                  }, 8, ["disabled"])
                ]),
                _: 1
              }),
              o(c, { name: "password" }, {
                default: s(() => [
                  o(f, {
                    value: r(a).password,
                    "onUpdate:value": e[2] || (e[2] = (i) => r(a).password = i),
                    type: "password",
                    allowClear: "",
                    class: "input-item",
                    placeholder: "密码6到16位，包含数字和大小写字母"
                  }, {
                    prefix: s(() => [
                      o(n, { icon: "LockOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              }),
              o(c, { name: "confirmPassword" }, {
                default: s(() => [
                  o(f, {
                    type: "password",
                    value: r(a).confirmPassword,
                    "onUpdate:value": e[3] || (e[3] = (i) => r(a).confirmPassword = i),
                    class: "input-item",
                    allowClear: "",
                    placeholder: "确认密码"
                  }, {
                    prefix: s(() => [
                      o(n, { icon: "LockOutlined" })
                    ]),
                    _: 1
                  }, 8, ["value"])
                ]),
                _: 1
              }),
              u("div", te, [
                o(d, {
                  type: "primary",
                  block: "",
                  onClick: E,
                  class: "input-item",
                  loading: r(b)
                }, {
                  default: s(() => [
                    y(" 确定 ")
                  ]),
                  _: 1
                }, 8, ["loading"])
              ]),
              u("div", se, [
                o(d, {
                  class: "btn-forget-passwd",
                  type: "link",
                  onClick: e[4] || (e[4] = () => A("update:status", r(X).SIGNING))
                }, {
                  default: s(() => [
                    y("立即登录")
                  ]),
                  _: 1
                })
              ])
            ]),
            _: 1
          }, 8, ["model", "rules"]),
          o(B, {
            class: "img-verify-code-wrapper",
            open: r(m),
            "onUpdate:open": e[6] || (e[6] = (i) => H(m) ? m.value = i : null),
            footer: null,
            onCancel: q
          }, {
            default: s(() => [
              u("div", ae, [
                ie,
                u("div", le, [
                  u("img", {
                    class: "img-verify-code",
                    style: J({ "background-image": `url(${r(P)})` })
                  }, null, 4),
                  o(d, {
                    class: "btn-change-code",
                    type: "link",
                    onClick: V
                  }, {
                    default: s(() => [
                      y("看不清，换一个")
                    ]),
                    _: 1
                  })
                ]),
                o(R, {
                  ref_key: "codeFormRef",
                  ref: I,
                  model: r(v),
                  rules: r($)
                }, {
                  default: s(() => [
                    o(c, {
                      class: "input-img-code",
                      name: "imgVerifyCode"
                    }, {
                      default: s(() => [
                        o(f, {
                          ref_key: "verifyInputRef",
                          ref: w,
                          value: r(v).imgVerifyCode,
                          "onUpdate:value": e[5] || (e[5] = (i) => r(v).imgVerifyCode = i),
                          maxLength: 4,
                          allowClear: !0,
                          placeholder: "验证码"
                        }, null, 8, ["value"])
                      ]),
                      _: 1
                    }),
                    o(d, {
                      type: "primary",
                      block: "",
                      onClick: L,
                      class: "input-item",
                      loading: r(k)
                    }, {
                      default: s(() => [
                        y(" 确定 ")
                      ]),
                      _: 1
                    }, 8, ["loading"])
                  ]),
                  _: 1
                }, 8, ["model", "rules"])
              ])
            ]),
            _: 1
          }, 8, ["open"])
        ])
      ]);
    };
  }
});
export {
  ve as default
};
