import a from "../../apis/role/index.ts";
import "lodash";
const m = [
  {
    operator: "like",
    renderer: {
      type: "TextField",
      options: {
        field: "username",
        label: "用户名"
      }
    }
  },
  {
    operator: "like",
    renderer: {
      type: "TextField",
      options: {
        field: "nickname",
        label: "姓名"
      }
    }
  },
  {
    operator: "like",
    renderer: {
      type: "TextField",
      options: {
        field: "phone",
        label: "手机"
      }
    }
  }
], c = [
  {
    key: "_edit",
    label: "编辑"
    // color: '#f00',
    // expression: 'state=='1''
  },
  {
    key: "_reset",
    label: "重置",
    confirm: !0
  },
  {
    key: "_delete",
    label: "删除",
    color: "#f00",
    confirm: !0,
    showRoles: ["admin"]
  },
  {
    key: "_stop",
    label: "停用",
    color: "#f00",
    confirm: !0,
    expression: (e) => e.enabled
  },
  {
    key: "_start",
    label: "启用",
    color: "green",
    confirm: !0,
    expression: (e) => !e.enabled
  }
], y = [
  { key: "_add", label: "添加", icon: "UserAddOutlined" }
], u = [
  {
    name: "username",
    label: "用户名",
    align: "center"
  },
  {
    name: "nickname",
    label: "姓名",
    align: "center"
  },
  {
    name: "phone",
    label: "手机号",
    align: "center"
  },
  {
    name: "role_name",
    type: "json",
    label: "角色",
    align: "center"
  },
  {
    name: "enabled",
    align: "center",
    label: "状态",
    dict: "状态"
  }
], b = [
  {
    name: "yn",
    type: "inline",
    items: [
      {
        label: "是",
        value: !0
      },
      {
        label: "否",
        value: !1
      }
    ]
  },
  {
    name: "状态",
    type: "inline",
    items: [
      {
        label: "已停用",
        value: !1,
        tagColor: "error",
        tag: !0
      },
      {
        label: "运行中",
        value: !0,
        tagColor: "success",
        tag: !0
      }
    ]
  }
], o = [
  {
    name: "hideshow",
    type: "inline",
    items: [
      {
        label: "显示",
        value: 1
      },
      {
        label: "隐藏",
        value: 0
      }
    ]
  },
  {
    name: "yn",
    type: "inline",
    items: [
      {
        label: "是",
        value: 1
      },
      {
        label: "否",
        value: 0
      }
    ]
  },
  {
    name: "componenturi",
    type: "inline"
  }
], r = {
  hide: "hideshow",
  secondmenu: "yn"
}, n = {}, f = [
  {
    type: "TextField",
    options: {
      type: "text",
      field: "username",
      label: "用户名",
      required: !0
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "password",
      label: "密码",
      mode: "password",
      required: !0
    }
  }
], x = [
  {
    type: "TextField",
    options: {
      type: "text",
      field: "nickname",
      label: "姓名",
      required: !0
    }
  },
  {
    type: "SelectField",
    options: {
      type: "json",
      mode: "multiple",
      field: "roles",
      dictRef: "role",
      required: !0,
      label: "角色"
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "phone",
      maxLength: 11,
      label: "手机号"
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "email",
      label: "邮箱"
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "company",
      label: "单位"
    }
  },
  {
    type: "TextField",
    options: {
      type: "text",
      field: "department",
      label: "科室"
    }
  }
], i = {
  fieldValidators: [
    {
      field: "username",
      label: "用户名",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^\S+$/,
            message: "用户名不能包含空格"
          }
        },
        {
          type: "regex",
          options: {
            pattern: /^[a-zA-Z][a-zA-Z0-9]{3,15}$/,
            message: "必须由英文开头,仅可包含英文和数字,4-16位"
          }
        }
      ]
    },
    {
      field: "password",
      label: "密码",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^[a-zA-Z0-9]{6,16}$/,
            message: "仅可包含英文和数字,6-16位"
          }
        }
      ]
    },
    {
      field: "phone",
      label: "手机号",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^1(3[0-9]|4[5,7]|5[0,1,2,3,5,6,7,8,9]|6[2,5,6,7]|7[0,1,2,3,5,6,7,8]|8[0-9]|9[1,5,8,9])\d{8}$/,
            message: "请输入正确的手机号"
          }
        }
      ]
    },
    {
      field: "email",
      label: "邮箱",
      validators: [
        {
          type: "regex",
          options: {
            pattern: /^[a-z0-9]+([._\\-]*[a-z0-9])*@([a-z0-9]+[-a-z0-9]*[a-z0-9]+.){1,63}[a-z0-9]+$/,
            message: "请输入正确的邮箱"
          }
        }
      ]
    }
  ]
}, s = {
  layout: n,
  formDicts: o,
  dictRefs: r,
  validators: i
}, g = {
  formDef: s,
  formRecordData: {}
};
async function v() {
  let e = [];
  try {
    const { list: t } = await a.queryAllRole();
    e = t.map((l) => ({ label: l.name, value: l._id }));
  } catch (t) {
    console.error(t);
  }
  return e;
}
export {
  f as adminLayout,
  x as baseLayout,
  b as dicts,
  u as fields,
  o as formDicts,
  g as formOptions,
  v as getRoles,
  c as recordOperators,
  m as searchItems,
  y as tableOperators
};
