import typescript from 'rollup-plugin-typescript2'
import resolve from 'rollup-plugin-node-resolve'
import alias from 'rollup-plugin-alias'
import { fileURLToPath, URL } from 'node:url'
export default {
  input: './src/index.ts', // 入口文件
  output: {
    file: 'dist/bundle.js', //打包文件地址
    format: 'es',
    inlineDynamicImports: true
  },
  plugins: [
    typescript(),
    alias({
      entries: [{ find: '@', replacement: fileURLToPath(new URL('./src', import.meta.url)) }]
    }),
    resolve()
  ]
}
